SystemOrganization addCategory: #'GT-Spotter-EventRecorder-Analysis'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Builders'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Core'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Support'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Tests'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Traits'!

Trait named: #TGTABookmarkIt
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 10:30'!
bookmarkIt
	self explicitRequirement! !

!TGTABookmarkIt methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:47'!
bookmarks
	self explicitRequirement! !

!TGTABookmarkIt methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:27'!
gtInspectorActionBookmarkIt
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self bookmarkIt ];
		icon: Smalltalk ui icons glamorousBookmark;
		title: 'Bookmark It'! !

!TGTABookmarkIt methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:30'!
gtInspectorBookmarksIn: composite
	<gtInspectorPresentationOrder: -1>
	composite tabulator 
		when: [ self isBookmarked ];
		title: 'Bookmarks';
		with: [ :browser | 
			browser
				row: #list;
				row: #description.
			browser transmit 
				to: #list;
				andShow: [ :c |
					c list 
						display: [ self relatedBookmarks ];
						format: [ :aBookmark | 
							GTObjectPrinter new asTruncatedTextFrom: aBookmark description asString ];
						updateOn: GTACollectionAnnouncement 
							from: [ :aEventCollection | 
										aEventCollection bookmarks announcer ];
						selectionAct: [ :list :relatedBookmarks |
							self removeBookmark: list selection.
							list update ]
							entitled: 'Remove bookmark' ].
			browser transmit
				to: #description;
				from: #list port: #selection;
				andShow: [ :c |
					c rubricText
						display: #description;
						act: [ :port :bookmark | 
								bookmark description: port text asString.
								self bookmarks save.
								port pane browser panes do: #update ] 
							on: $s
							entitled: 'Save' ]
		] ! !

!TGTABookmarkIt methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:49'!
isBookmarked
	^ self bookmarks hasRelatedTo: self! !

!TGTABookmarkIt methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:48'!
relatedBookmarks
	^ self bookmarks relatedTo: self! !

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 13:06'!
removeBookmark: aBookmark
	self bookmarks 
		removeBookmark: aBookmark;
		save.! !

Trait named: #TGTSpotterCategoryView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterCategoryView methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:58'!
categoryLabelOccurrences
	| col |
	col := OrderedCollection new.
	self categoryLabels asBag 
		doWithOccurrences: [ :obj :occurrences | 
			col add: obj -> occurrences ].
	^ col! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/31/2015 10:03'!
categoryView
	| b ds points |
	b := RTGrapher new.
	points := self categoryLabelOccurrences sortedAs: [ :x :y | x value > y value ].
	points ifEmpty: [ ^ b view ].
	b extent: ((points size * 30) min: 800) @ 150.
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj key asString, ', ', obj value asString, ' times' ].
	ds points: points.
	ds barShape 
			color: (Color green alpha: 0.3); 
			width: 10.
	ds histogramWithBarTitle: #key.
	ds y: [ :obj | obj value ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:30'!
gtInspectorCategoryViewIn: composite
	<gtInspectorPresentationOrder: -2>
	composite roassal2
		title: 'Category';
		initializeView: [ self categoryView ]
		! !

Trait named: #TGTSpotterDurationView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:09'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 10:56'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

Trait named: #TGTSpotterSessionsTable
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterSessionsTable methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 11:03'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Sessions';
		display: [ :anEvent | anEvent sessions ];
		column: 'Start' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each start ] width: 155;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each withPreviewSymbol ]
			width: 57;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		showOnly: 50! !

Trait named: #TGTSpotterUpdateEvents
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterUpdateEvents methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/9/2015 10:54'!
gtInspectorActionRefreshEvents
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self updateEvents ];
		icon: Smalltalk ui icons glamorousRefresh;
		title: 'Update events'! !

OrderedCollection subclass: #GTAAnnouncements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 11:38'!
fromDirectory: aFileReference
	"self fromDirectory: './gt/events/' asFileReference"
	^ self 
		withAll: (GTSpotterEventRecorder materializeObjectsFromDirectory: aFileReference)! !

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 11:38'!
fromLocalDirectory
	GTATool ensureLocalDirectory.
	^ self fromDirectory: './gt/events/' asFileReference! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:08'!
spotterDevelopers
	"self spotterDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				developers
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:07'!
spotterUsers
	"self spotterUsers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				users
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 5/11/2015 23:48'!
spotterUsersAndDevelopers
	"self spotterUsersAndDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
					sessionsPerComputer
						"sessionsWithNumberOfInputsGreaterThenOne"! !

!GTAAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 11:45'!
developerUUIDs
	^ GTAConfiguration developerUUIDs! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:30'!
developers
	^ self select: [ :each | self developerUUIDs includes: each computerUUID asString ]! !

!GTAAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 12:42'!
numberOfComputers
	^ self perComputer size! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/11/2015 16:11'!
perComputer
	^ (self groupedBy: [ :each | each computerUUID asString]) as: GTAAnnouncements! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:21'!
sessions
	^ GTSpotterSessionsBuilder fromEvents: (
			self flatCollect: #events as: OrderedCollection)! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 14:41'!
sessionsPerComputer
	| group computers |
	group := self perComputer.
	computers := group collect: [ :eachComputer |
		eachComputer sortByTimestamp.
		eachComputer sessions.
	] as: GTAComputers.
	computers := computers removeAllSuchThat: #isEmpty.
	computers do: [ :eachComputer | eachComputer computers: computers ].
	computers updateEvents.
	^ computers! !

!GTAAnnouncements methodsFor: 'sorting' stamp: 'JurajKubelka 3/29/2015 12:42'!
sortByTimestamp
	^ self sort: [ :a :b | a timestamp < b timestamp ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:31'!
users
	^ self select: [ :each | (self developerUUIDs includes: each computerUUID asString) not ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 12:42'!
withoutEmptyComputerUUID
	^ self select: [ :each | each computerUUID notNil and: [ (each computerUUID = 'nil') not ] ]! !

OrderedCollection subclass: #GTABookmarks
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTABookmarks class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 18:17'!
from: aCollection computers: aCollection2 
	^ (self new: aCollection size + 10)
			from: aCollection computers: aCollection2;
			yourself! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 12:36'!
addComputer: aGTAComputer description: aString 
	| item |
	item := self add: (GTAComputerBookmark new item: aGTAComputer; description: aString; yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 12:36'!
addSession: aGTASession description: aString 
	| item |
	item := self add: (GTASessionBookmark new item: aGTASession; description: aString; yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 13:07'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTABookmarks methodsFor: 'initialization' stamp: 'JurajKubelka 5/13/2015 18:20'!
from: aCollection computers: aGTAComputers
	aCollection do: [ :eachBookmarkPath | | bookmark |
		bookmark := eachBookmarkPath first new
							from: eachBookmarkPath computers: aGTAComputers;
							yourself.
		self add: bookmark.
	]! !

!GTABookmarks methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:59'!
hasRelatedTo: anObject 
	^ self anySatisfy: [ :eachBookmark | eachBookmark isRelatedTo: anObject ]! !

!GTABookmarks methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 11:04'!
relatedTo: anObject 
	^ (self select: [ :eachBookmark | eachBookmark isRelatedTo: anObject ]) as: OrderedCollection! !

!GTABookmarks methodsFor: 'removing' stamp: 'JurajKubelka 5/14/2015 13:04'!
removeBookmark: aBookmark
	| item |
	item := self remove: aBookmark.
	self announcer announce: GTAItemRemoved.
	^ item! !

!GTABookmarks methodsFor: 'storing' stamp: 'JurajKubelka 5/14/2015 12:51'!
save
	GTAConfiguration saveBookmarks: self.
	self announcer announce: GTASaved! !

OrderedCollection subclass: #GTACollection
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:07'!
duration
	^ self end - self start! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:08'!
end
	self ifEmpty: [ ^ 0 ].
	^ self last end! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key
	^ self optionAt: key ifAbsent: [ nil ]! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key ifAbsent: absentBlock
	options ifNil: [ ^ absentBlock value ].
	^ options at: key ifAbsent: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:11'!
optionAt: key ifAbsentPut: absentBlock
	options ifNil: [ options := Dictionary new ].
	^ options at: key ifAbsentPut: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key put: value
	options ifNil: [ options := Dictionary new ].
	^ options at: key put: value! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:09'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first start! !

GTACollection subclass: #GTAEventCollection
	uses: TGTABookmarkIt + TGTSpotterCategoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTAEventCollection class
	uses: TGTABookmarkIt classTrait + TGTSpotterCategoryView classTrait
	instanceVariableNames: ''!

!GTAEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:33'!
computerUUID
	self ifEmpty: [ ^ 0 ].
	^ self any computerUUID! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:40'!
contextChanges
	^ self select: #isContextChanged! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:14'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesIn
	^ self select: #isDiveIn! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesOut
	^ self select: #isDiveOut! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:55'!
finishedSearches
	^ self select: #isSearchFinished! !

!GTAEventCollection methodsFor: 'testing' stamp: 'JurajKubelka 4/9/2015 10:51'!
hasMissSteps
	^ self missSteps notEmpty! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/14/2015 17:44'!
humanReadablePrintString
	"Return a String with a human readable representation of me"
	^ String streamContents: [ :out | 
		self printHumanReadableOn: out ]! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:40'!
numberOfContextChanged
	^ self contextChanges size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 12:15'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesIn
	^ self divesIn size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesOut
	^ self divesOut size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:54'!
numberOfFinishedSearches
	^ self finishedSearches size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 4/9/2015 10:52'!
numberOfMissSteps
	^ self missSteps size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:43'!
numberOfUserSelections
	^ self userSelections size! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
sessionPopupText
	^ String streamContents: [ :aStream |
			self sessionPopupTextOn: aStream
		 ]! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
sessionPopupTextOn: aStream
	aStream
		nextPutAll: 'Duration: ';
		print: self duration;
		cr;
		nextPutAll: 'Events: ';
		print: self size;
		cr;
		nextPutAll: 'Number of user input changes: ';
		print: self numberOfContextChanged;
		cr;
		nextPutAll: 'Number of different search strings: ';
		print: self numberOfDifferentSearchStrings;
		cr;
		nextPutAll: 'Number of finished searches: ';
		print: self numberOfFinishedSearches;
		cr;
		nextPutAll: 'Number of user item selections: ';
		print: self numberOfUserSelections;
		cr;
		nextPutAll: 'Dive in/out: ';
		print: self numberOfDivesIn;
		nextPut: $/;
		print: self numberOfDivesOut;
		cr;
		"using of #i, etc."
		nextPutAll: (self isWithPreview ifTrue: [ 'With Preview' ] ifFalse: [ 'Without Preview' ])! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:44'!
userSelections
	^ self select: #isUserSelection! !

GTAEventCollection subclass: #GTASession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:16'!
activityView
	| builder |
	builder := GTATimelineBuilder new.
	builder 
		configuration: GTADefaultTimelineConfiguration uniqueInstance;
		events: self;
		build.
	GTAMenuBuilder new timelineBuilder: builder; build.
	builder view canvas focusOnCenterScaled.
	^ builder view.! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:18'!
activityView3
	"obsolete"
	^ GTSpotterTimeline viewOn: self! !

!GTASession methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 10:42'!
bookmarkIt
	self bookmarks
		addSession: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:40'!
bookmarks
	^ self computer bookmarks ! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:47'!
categoryLabels
	^ self categorySelections collect: #categoryLabel as: OrderedCollection! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:45'!
categorySelections
	^ self select: #isCategorySelection! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 10:50'!
closeActionSymbol
	self ifEmpty: [ ^ #empty ].
	^ self last closeActionSymbol! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 4/20/2015 11:28'!
computer
	^ self optionAt: #computer! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 4/20/2015 11:28'!
computer: aGTSpotterComputer
	^ self optionAt: #computer put: aGTSpotterComputer! !

!GTASession methodsFor: 'comparing' stamp: 'JurajKubelka 4/9/2015 20:19'!
deepestDiveIn
	^ self max: #diveInLevel! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:08'!
end
	self ifEmpty: [ ^ 0 ].
	^ self last dateAndTimeWithFixedTimeZone! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorActivityView3In: composite
	<gtInspectorPresentationOrder: -5>
	"obsolete"
	composite roassal2
		title: 'Activity 3';
		initializeView: [ self activityView3 ]
		! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorActivityViewIn: composite
	<gtInspectorPresentationOrder: -6>
	composite roassal2
		title: 'Activity';
		initializeView: [ self activityView ]
		! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:28'!
gtInspectorEventsIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Events';
		display: [ :aSession | aSession ];
		column: 'Event' 
			evaluated: [ :each | each asEventAnalysisString ] width: 400;
		column: 'Time' 
			evaluated: [ :each | GTSpotterPrintDateAndTime yyyyMmDdAndHhMmSs: each dateAndTimeWithFixedTimeZone ]
			width: 120;
		withSmalltalkSearch;
		helpMessage: 'Given your INPUT, it executes: self select: [:each | INPUT ]';
		showOnly: 200! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/31/2015 13:53'!
gtInspectorStrangeEventsIn: composite
	<gtInspectorPresentationOrder: 9>  
	^ (composite tree)
		title: 'Strange';
		display: [ :aSession | aSession select: #isStrange ];
		children: [ :eachChild |
			eachChild isString 
				ifTrue: [ #() ]
				ifFalse: [ eachChild strange ] ];
		format: [ :eachEvent | 
			eachEvent isString 
				ifTrue: [ eachEvent ]
				ifFalse: [ eachEvent asEventAnalysisString, 
								' with ', eachEvent strange size asString, ' strange observations.' ] ]! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorTreeEventsIn: composite
	<gtInspectorPresentationOrder: -8>  
	^ (composite tree)
		title: 'Tree';
		display: [ :aSession | aSession roots ];
		children: [ :eachChild |
			eachChild children ];
		format: [ :eachEvent | eachEvent asEventAnalysisString ]
		! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:53'!
hasSpecialKeywords
	^ self anySatisfy: [ :each | each isContextChanged and: [ each hasCurrentTextSpecials ] ]! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:19'!
imageHashes
	^ (self collect: #imageHash as: OrderedCollection) removeDuplicates! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:45'!
isWithPreview
	^ (self contains: #isShowPreview) and: [ 
			(self contains: #isHidePreview) not ]! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 12:02'!
missSteps
	| collection |
	collection := self select: #isMissStep.
	collection computer: self computer.
	^ collection! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:50'!
previewString
	^ self isWithPreview
		ifTrue: [ 'yes' ]
		ifFalse: [ 'no' ]! !

!GTASession methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
printHumanReadableOn: aStream 
	self sessionPopupTextOn: aStream! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 13:04'!
roots
	^ self select: #isRootEvent! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:10'!
searchStrings
	^ ((self select: #isContextChanged)
			flatCollect: #currentTextHashes as: Bag)! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:57'!
specialKeywords
	^ self select: [ :each | each isContextChanged and: [ each hasCurrentTextSpecials ] ]! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:08'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first dateAndTimeWithFixedTimeZone! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:20'!
timelineView2
	self 
		deprecated: 'Use activityView instead'
		on: 	'14 May 2015' 
		in: 'GT-Spotter-EventRecorder-Analysis-Core'.
	^ self activityView! !

!GTASession methodsFor: 'update' stamp: 'JurajKubelka 4/9/2015 11:13'!
updateEvents
	^ GTSpotterSessionAnalysis updateOn: self! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:45'!
userQueryOrSelectionHashes
	^ self flatCollect: #userQueryOrSelectionHashes as: OrderedCollection ! !

GTAEventCollection subclass: #GTASomeSessions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASomeSessions subclass: #GTAComputer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:35'!
avgNumberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesIn) / self size! !

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:35'!
avgNumberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesOut) / self size! !

!GTAComputer methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 12:23'!
bookmarkIt
	self bookmarks
		addComputer: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:41'!
bookmarks
	^ self computers bookmarks! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:52'!
computers
	^ self optionAt: #computers! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:52'!
computers: aCollection 
	^ self optionAt: #computers put: aCollection! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 15:28'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 15:35'!
flatCollectEvents: aBlock 
	^ self flatCollect: [ :eachSession | eachSession select: aBlock ] as: OrderedCollection! !

!GTAComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/12/2015 00:27'!
hasSessionsWithSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:54'!
hasSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'testing' stamp: 'JurajKubelka 5/13/2015 11:44'!
isDeveloper
	^ GTAConfiguration isDeveloper: self computerUUID! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 5/11/2015 16:11'!
missSteps
	^ self flatCollect: #missSteps as: GTASession! !

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/31/2015 15:26'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged! !

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/31/2015 15:27'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesIn	! !

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesOut! !

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 16:34'!
numberOfEvents
	self ifEmpty: [ ^ 0 ].
	^ self sum: #size! !

!GTAComputer methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:30'!
numberOfPreviews
	^ self sessionsWithPreview size! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 15:30'!
searchStrings
	^ self flatCollect: #searchStrings as: Bag! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self select: [ :each | each numberOfContextChanged > anInteger ]! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:32'!
sessionsWithPreview
	^ self select: #isWithPreview! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/11/2015 23:59'!
sessionsWithSpecialKeywords
	^ self select: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:58'!
specialKeywords
	^ self flatCollect: #specialKeywords as: OrderedCollection! !

!GTAComputer methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:43'!
updateEvents
	^ self do: #updateEvents! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 00:44'!
userOrDeveloperString
	^ self isDeveloper
			ifTrue: [ 'dev' ]
			ifFalse: [ 'user' ]! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:44'!
userQueryOrSelectionHashes
	^ self flatCollect: #userQueryOrSelectionHashes as: OrderedCollection! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:09'!
activityView
	| composer builders |
	composer := RTComposer new.
	composer view @ RTZoomableView.
	builders := GTATimelineBuilders new.
	1 to: (self size min: 50) do: [ :index | | builder |
		builder := GTATimelineBuilder new.
		builder 
			view: composer view;
			configuration: GTADefaultTimelineConfiguration uniqueInstance;
			events: (self at: index);
			build.
		composer group: index.
		index > 1 ifTrue: [ composer move: index belowAlignFromLeft: index - 1 ].
		builders add: builder.
	 ].
	GTAMenuBuilder new timelineBuilder: builders; build.
	composer view canvas focusOnCenterScaled.
	^ composer view.! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
bookmarks
	^ self computer bookmarks! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 18:07'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
computer
	^ self optionAt: #computer! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
computer: aCollection 
	^ self optionAt: #computer put: aCollection! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:11'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:10'!
gtInspectorActivityViewIn: composite
	<gtInspectorPresentationOrder: -6>
	composite roassal2
		title: 'Activity';
		initializeView: [ self activityView ]
		! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:11'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: -1>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:12'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Sessions';
		display: [ :aComputer | aComputer ];
		column: 'Start' 
			evaluated: [ :each | String streamContents: [ :aStream | | start |
											start := each start.
											start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [
													start asUTC printYMDOn: aStream.
													aStream nextPutAll: ', '.
													start asUTC printHMSOn: aStream ] ] ]
			width: 120;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each previewString ]
			width: 57;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 67;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Fin. Searches' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 83;
		column: 'Selections' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfUserSelections ]
			width: 70;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Close' 
			evaluated: [ :each | each closeActionSymbol ]
			width: 63;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		beMultiple;
		send: [ :result | GTAMultipleSelectionSendCommand selection: result in: self ];
		showOnly: 200! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:08'!
gtInspectorTimelineViewIn: composite
	<gtInspectorPresentationOrder: -8>
	composite roassal2
		title: 'Timeline';
		initializeView: [ self timelineView ]
		! !

!GTASomeSessions methodsFor: 'printing' stamp: 'JurajKubelka 5/14/2015 17:45'!
printHumanReadableOn: aStream
	| duration |
	aStream 
		print: self size; 
		nextPutAll: ' events from '; 
		print: self start asDate; 
		cr;
		nextPutAll: ' during '. 
	duration := self duration.
	self duration > 1 second ifTrue: [ duration := self duration truncateTo: 1 milliseconds ].
	self duration > 1 minute ifTrue: [ duration := self duration truncateTo: 1 second ].
	self duration > 1 hour ifTrue: [ duration := self duration truncateTo: 1 minute ].
	self duration > 1 day ifTrue: [ duration := self duration truncateTo: 1 hour ].
	duration printHumanReadableOn: aStream! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 17:47'!
spentTime
	self ifEmpty: [ ^ 0 seconds ].
	^ self sum: #duration! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:24'!
timelineView
	| builder minTime dataSetBuilder |
	builder := RTTimeLine new.
	minTime := self start asUnixTime.
	dataSetBuilder := GTARoughDataSetBuilder new
		gap: self duration / 48;
		setSessionComparator;
		newGroupBlock: [ GTASomeSessions new computer: self; yourself ];
		yourself.
	dataSetBuilder objects: self; build.
	dataSetBuilder groups do: [ :eachGroup | | entry model |
		entry := RTTimeLineEntry new.
		model := eachGroup size = 1
			ifTrue: [ eachGroup any ]
			ifFalse: [ eachGroup ].
		entry 
			identifier: 1;
			model: model;
			start: eachGroup start asUnixTime - minTime;
			end: eachGroup end asUnixTime - minTime.
		builder addEntry: entry.
	].
	builder axisX 
		numberOfLabels: 5;
		labelRotation: -45;
		labelConversion: [ :unixTime | 
			GTADateAndTimeStringBuilder new
				dateAndTime: (DateAndTime fromUnixTime: unixTime + minTime);
				duration: self duration;
				numberOfLabels: 5;
				humanReadablePrintString ].
	builder axisY noLabel.
	builder interaction popup text: #humanReadablePrintString.
	builder shape color: (RTMultiLinearColorForIdentity new objects: builder entries).
	^ builder ! !

GTACollection subclass: #GTASessions
	uses: TGTSpotterDurationView + TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASessions class
	uses: TGTSpotterDurationView classTrait + TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTASessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 11:14'!
duration
	^ self end - self start! !

!GTASessions methodsFor: 'gt-inspector-extension' stamp: ''!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTASessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 11:14'!
end
	^ (self detectMax: #end)  ifNil: [ 0 ] ifNotNil: [ :obj | obj end ]! !

!GTASessions methodsFor: 'gt-inspector-extension' stamp: ''!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTASessions methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 11:20'!
numberOfEvents
	^ self sum: #size! !

!GTASessions methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 10:37'!
sessions
	^ self! !

!GTASessions methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 10:37'!
start
	^ (self detectMin: #start) ifNil: [ 0 ] ifNotNil: [ :obj | obj start ]! !

GTACollection subclass: #GTASomeComputers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASomeComputers subclass: #GTAComputers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTAComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:13'!
bookmarks
	^ self optionAt: #bookmarks ifAbsentPut: [ GTAConfiguration loadBookmarks: self ]! !

!GTAComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:17'!
gtInspectorBookmarksIn: composite
	<gtInspectorPresentationOrder: 9>
	(composite table)
		title: 'Bookmarks';
		display: [ :aComputers | aComputers bookmarks ];
		column: 'Description'
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each description asString ];
		act: [ :Presentation :aComputers | aComputers saveBookmarks ]
			icon: Smalltalk ui icons glamorousSave
			entitled: 'Save bookmarks';
		selectionPopulate: #selection
			entitled: 'Open bookmark'
			with: [ :aTable | aTable rawSelection gtInspectorInterestingObject ];
		updateOn: GTACollectionAnnouncement 
			from: [ :aComputers | aComputers bookmarks announcer ];
		send: [ :result | result ifNotNil: [ result item ] ];
		showOnly: 50 ! !

!GTAComputers methodsFor: 'update' stamp: 'JurajKubelka 5/13/2015 18:42'!
saveBookmarks
	self bookmarks ifNotEmpty: [ self bookmarks save ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
computerUUIDs
	^ self collect: #computerUUID as: OrderedCollection! !

!GTASomeComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:51'!
computers
	^ self optionAt: #computers! !

!GTASomeComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:51'!
computers: aCollection 
	^ self optionAt: #computers put: aCollection! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
computersAndOnlySessionsWithSpecialKeywords
	^ self 
		select: [ :computer | computer hasSessionsWithSpecialKeywords ]
		thenCollect: [ :computer | 
			computer sessionsWithSpecialKeywords	]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
flatCollectEvents: aBlock 
	^ self flatCollect: [ :eachComputer | eachComputer flatCollectEvents: aBlock ] as: OrderedCollection! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/13/2015 19:43'!
gtInspectorComputersIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Computers';
		display: [ :aComputer | aComputer ];
		column: 'Since' 
			evaluated: [ :each | String streamContents: [ :aStream | 
											each start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [ each start asUTC printYMDOn: aStream ] ] ]
			width: 67;
		column: 'Days' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration asDuration asDays rounded ] 
			width: 40;
		column: 'Spent' 
			evaluated: [ :each | each spentTime ] 
			width: 63;
		column: 'User' 
			evaluated: [ :each | each userOrDeveloperString ] 
			width: 50;
		column: 'Sessions' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] 
			width: 60;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfEvents ] 
			width: 50;
		column: 'Previews' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfPreviews ] 
			width: 60;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Dives Out' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesOut ]
			width: 63;
		column: 'Avg. D-In' 
			evaluated: [ :each | (each avgNumberOfDivesIn printShowingDecimalPlaces: 2)]
			width: 60;
		column: 'Avg. D-Out' 
			evaluated: [ :each | (each avgNumberOfDivesOut printShowingDecimalPlaces: 2) ]
			width: 67;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 60;
		beMultiple;
		send: [ :result | GTAMultipleSelectionSendCommand selection: result in: self as: GTASomeComputers ];
		showOnly: 100! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:46'!
gtInspectorTimelineViewIn: composite
	<gtInspectorPresentationOrder: 6>
	composite roassal2
		title: 'Timeline';
		initializeView: [ self timelineView ]
		! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
missSteps
	^ self flatCollect: #missSteps as: GTASession! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged ! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfEvents
	^ self sum: [ :each | each numberOfEvents ]! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfMissSteps
	^ self missSteps size! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfSessions
	^ self sum: [ :each | each size ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessions
	^ self flatCollect: #yourself as: GTASessions! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self collect: [ :each | each copy sessionsWithNumberOfInputsGreaterThen: anInteger ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
specialKeywords
	^ self flatCollect: #specialKeywords as: OrderedCollection! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/15/2015 09:50'!
timelineView
	| builder minTime dataSetBuilder |
	builder := RTTimeLine new.
	minTime := self start asUnixTime.
	dataSetBuilder := GTARoughDataSetBuilder new
		gap: self duration / 48;
		setSessionComparator;
		yourself.
	self reverseWithIndexDo: [ :eachComputer :index | 
		dataSetBuilder 
			objects: eachComputer; 
			newGroupBlock: [ GTASomeSessions new computer: eachComputer; yourself ];
			build.
		dataSetBuilder groups do: [ :eachGroup | | entry model |
			entry := RTTimeLineEntry new.
			model := eachGroup size = 1
				ifTrue: [ eachGroup any ]
				ifFalse: [ eachGroup ].
			entry 
				identifier: index;
				model: model;
				start: eachGroup start asUnixTime - minTime;
				end: eachGroup end asUnixTime - minTime.
			builder addEntry: entry.
		].
	 ].
	builder axisX 
		numberOfLabels: 5;
		labelRotation: -45;
		labelConversion: [ :unixTime | 
			GTADateAndTimeStringBuilder new
				dateAndTime: (DateAndTime fromUnixTime: unixTime + minTime);
				duration: self duration;
				numberOfLabels: 5;
				humanReadablePrintString ].
	builder axisY noLabel.
	builder interaction popup text: #humanReadablePrintString.
	builder shape color: (RTMultiLinearColorForIdentity new 
							command: #identifier; 
							objects: (1 to: self size);
							yourself).
	^ builder ! !

!GTASomeComputers methodsFor: 'update' stamp: 'JurajKubelka 5/13/2015 19:43'!
updateEvents
	^ self do: #updateEvents! !

OrderedCollection subclass: #GTAGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:27'!
duration
	^ self end - self start! !

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:01'!
end
	^ self last end! !

!GTAGroup methodsFor: 'printing' stamp: 'JurajKubelka 5/14/2015 17:10'!
humanReadablePrintString
	"Return a String with a human readable representation of me"
	^ String streamContents: [ :out | 
		self printHumanReadableOn: out ]! !

!GTAGroup methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:02'!
printHumanReadableOn: aStream
	| duration |
	aStream 
		print: self size; 
		nextPutAll: ' events from '; 
		print: self start asDate; 
		cr;
		nextPutAll: ' during '. 
	duration := self duration.
	self duration > 1 second ifTrue: [ duration := self duration truncateTo: 1 milliseconds ].
	self duration > 1 minute ifTrue: [ duration := self duration truncateTo: 1 second ].
	self duration > 1 hour ifTrue: [ duration := self duration truncateTo: 1 minute ].
	self duration > 1 day ifTrue: [ duration := self duration truncateTo: 1 hour ].
	duration printHumanReadableOn: aStream! !

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:00'!
start
	^ self first start! !

OrderedCollection subclass: #GTAGroups
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

OrderedCollection subclass: #GTATimelineBuilders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineBuilders methodsFor: 'adding' stamp: 'JurajKubelka 4/15/2015 16:03'!
addEdges
	self do: #addEdges! !

!GTATimelineBuilders methodsFor: 'building' stamp: 'JurajKubelka 4/16/2015 15:20'!
build
	self do: #build.
	self layoutSessions! !

!GTATimelineBuilders methodsFor: 'testing' stamp: 'JurajKubelka 4/15/2015 16:02'!
isWithEdges
	^ self anyOne isWithEdges! !

!GTATimelineBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:00'!
layout
	^ self anyOne layout! !

!GTATimelineBuilders methodsFor: 'layout' stamp: 'JurajKubelka 4/16/2015 15:19'!
layoutElements
	self do: #layoutElements.
	self layoutSessions! !

!GTATimelineBuilders methodsFor: 'layout' stamp: 'JurajKubelka 4/16/2015 15:19'!
layoutSessions
	| previousBuilder |
	self
		withIndexDo: [ :builder :index | 
			builder layoutElements.
			index > 1
				ifTrue: [ TRConstraint move: builder elements belowAlignFromLeft: previousBuilder elements gap: 20 ].
			previousBuilder := builder ]! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 15:59'!
logicalLayout
	self do: #logicalLayout! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:01'!
realLayout
	self do: #realLayout! !

!GTATimelineBuilders methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 4/16/2015 15:17'!
removeAllElementsAndEdges
	self do: #removeAllElementsAndEdges! !

!GTATimelineBuilders methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 16:02'!
removeEdges
	self do: #removeEdges! !

!GTATimelineBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/16/2015 15:16'!
shape
	^ self collect: #shape as: GTATimelineShapeBuilders! !

!GTATimelineBuilders methodsFor: 'signalling' stamp: 'JurajKubelka 4/15/2015 16:07'!
signalUpdate
	self ifEmpty: [ ^ self ].
	self view signalUpdate! !

!GTATimelineBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:58'!
view
	^ self anyOne view! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:08'!
withEdges
	self do: #withEdges! !

!GTATimelineBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:02'!
withoutEdges
	self do: #withoutEdges! !

OrderedCollection subclass: #GTATimelineShapeBuilders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	self do: #flexibleResultShapes! !

!GTATimelineShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/15/2015 16:12'!
oblique
	self do: #oblique! !

!GTATimelineShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/15/2015 16:04'!
orthogonal
	self do: #orthogonal! !

!GTATimelineShapeBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:08'!
shape
	self ifEmpty: [ ^ nil ].
	^ self anyOne shape! !

RTBuilder subclass: #GTARoughTimeline
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTARoughTimeline methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/11/2015 16:46'!
objects: aCollection
	objects := aCollection! !

RTBuilder subclass: #GTATimelineBuilder
	instanceVariableNames: 'events elements eventAnalyzer eventFilter analyze edges edgeShapeBuilder withEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineBuilder class methodsFor: 'api' stamp: 'JurajKubelka 4/13/2015 17:39'!
viewOn: objects
	| instance |
	instance := self new.
	instance
		events: objects;
		withEdges.
	instance interaction
		popupText: #asEventAnalysisString;
		draggable.
	^ instance
		build;
		view! !

!GTATimelineBuilder methodsFor: 'adding' stamp: 'JurajKubelka 4/14/2015 14:49'!
addEdges
	self edges ifNotEmpty: [ ^ self ].
	self buildEdges.! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/13/2015 16:41'!
analyze
	analyze := true! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 16:44'!
analyzeEvents
	self eventAnalyzer analyze: self events! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 16:43'!
analyzeEventsIfRequested
	analyze ifTrue: [ self analyzeEvents ]! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/14/2015 14:49'!
buildEdges
	| size |
	size := self elements size.
	size < 2
		ifTrue: [ ^ #() ].
	self elements
		withIndexDo: [ :element :index | 
			index < size
				ifTrue: [ self edgeFrom: element to: (self elements at: index + 1) ] ].
	^ self edges! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/14/2015 14:49'!
buildEdgesIfRequested
	withEdges
		ifFalse: [ ^ #() ].
	^ self buildEdges! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:09'!
buildElements
	| visibleEvents |
	visibleEvents := self visibleEvents.
	elements := self elementsWithInteractionOn: visibleEvents.
! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:52'!
configuration: aGTADefaultTimelineConfiguration 
	aGTADefaultTimelineConfiguration configure: self! !

!GTATimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/13/2015 16:55'!
createShapeBuilder
	^ super createShapeBuilder event; yourself! !

!GTATimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/13/2015 16:47'!
createView
	^ super createView @ RTDraggableView @ RTZoomableView.! !

!GTATimelineBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/14/2015 14:39'!
edgeFrom: source to: target 
	"source and target are elements"
	| newEdge |
	newEdge := self edgeShapeBuilder edgeFrom: source to: target.
	view add: newEdge.
	edges add: newEdge.
	^ newEdge! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 17:31'!
edgeShapeBuilder
	^ edgeShapeBuilder ifNil: [ edgeShapeBuilder := self newEdgeShapeBuilder ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 14:40'!
edges
	^ edges! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 15:29'!
elements
	elements ifNil: [ self buildElements ].
	^ elements! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:50'!
eventAnalyzer
	^ eventAnalyzer ifNil: [ eventAnalyzer := self newEventAnalyzer ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 15:10'!
eventFilter
	^ eventFilter ifNil: [ eventFilter := self newEventFilter ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:50'!
events
	^ events! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:48'!
events: aCollection 
	events := aCollection! !

!GTATimelineBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 4/14/2015 14:39'!
initialize
	super initialize.
	edges := OrderedCollection new.
	analyze := false.
	withEdges := false.! !

!GTATimelineBuilder methodsFor: 'testing' stamp: 'JurajKubelka 4/15/2015 15:05'!
isWithEdges
	^ withEdges ! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 15:16'!
layout
	^ layoutBuilder ifNil: [ layoutBuilder := self newLayoutBuilder ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 09:10'!
layout: aLayout
	^ layoutBuilder := aLayout! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:14'!
layoutElements
	self layoutElements: self elements! !

!GTATimelineBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:15'!
layoutElements: aCollection 
	self layout on: aCollection ! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/14/2015 14:29'!
logicalLayout
	^ self layout: GTAHorizontalDivingLineLayout new! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:01'!
newEdgeShapeBuilder
	^ self createShapeBuilder
		line;
		horizontalAttachPoint; 
		width: 1;
		yourself! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 14:50'!
newEventAnalyzer
	^ GTSpotterSessionAnalysis new! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 15:10'!
newEventFilter
	^ [ :session | session select: #isForTimelineView ]! !

!GTATimelineBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 09:07'!
newLayoutBuilder
	^ GTAHorizontalDivingLineLayout new center; yourself! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 15:13'!
realLayout
	^ self layout: GTAHorizontalRealTimelineLayout new! !

!GTATimelineBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/16/2015 15:16'!
removeAllElementsAndEdges
	self
		removeEdges;
		removeElements! !

!GTATimelineBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/14/2015 21:36'!
removeEdges
	self edges ifEmpty: [ ^ self ].
	"view removeEdges: self edges."
	self edges do: #remove.
	edges := OrderedCollection new.! !

!GTATimelineBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/14/2015 21:36'!
removeElements
	elements ifNil: [ ^ self ].
	self elements ifEmpty: [ ^ self ].
	self elements do: #remove.
	elements := nil! !

!GTATimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/16/2015 15:16'!
renderIn: aView
	self removeAllElementsAndEdges.
	self analyzeEventsIfRequested.
	aView addAll: self elements.
	self buildEdgesIfRequested.
	self layoutElements.! !

!GTATimelineBuilder methodsFor: 'signalling' stamp: 'JurajKubelka 4/14/2015 14:36'!
signalUpdate
	view signalUpdate ! !

!GTATimelineBuilder methodsFor: 'layout' stamp: 'JurajKubelka 4/14/2015 14:57'!
smoothLayoutTranslator
	self layout translator: (RTSmoothLayoutTranslator new nbCycles: 1).! !

!GTATimelineBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 4/13/2015 15:10'!
visibleEvents
	^ self eventFilter cull: self events cull: self! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/13/2015 17:09'!
withEdges
	withEdges := true! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:55'!
withEdges: aBoolean 
	withEdges := aBoolean! !

!GTATimelineBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/14/2015 15:17'!
withoutEdges
	withEdges := false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:27'!
analysisIcon
	^ GTSpotterEventIcons noIcon! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:47'!
asEventAnalysisString
	^ String streamContents: [ :stream |
			self eventAnalysisPrintOn: stream ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:38'!
children
	^ self infoAt: #sameLevelEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:17'!
cleanDiveInEvent: aDiveInEvent 
	^ self removeInfoAt: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:01'!
dateAndTimeWithFixedTimeZone
	| dateAndTime announcementTimestamp session dates |
	self infoAt: #dateAndTimeWithFixedTimeZone ifPresent: [ :value | ^ value ] ifAbsent: [ "ignore" ].
	dateAndTime := self dateAndTime.
	dateAndTime ifNil: [ ^ nil ].
	announcementTimestamp := self announcementTimestamp.
	announcementTimestamp ifNil: [ 
		^ dateAndTime translateTo: 0 ].
	dateAndTime asDate yyyymmdd = announcementTimestamp asDate yyyymmdd ifTrue: [ 
		^ self 
			infoAt: #dateAndTimeWithFixedTimeZone 
			put: (dateAndTime translateTo: announcementTimestamp offset) ].
	session := self session.
	session ifNil: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	dates := (session collect: #announcementTimestamp as: Set)
		select: [ :eachTimestamp | eachTimestamp asDate yyyymmdd = dateAndTime asDate yyyymmdd ].
	dates ifEmpty: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	^ self 
		infoAt: #dateAndTimeWithFixedTimeZone 
		put: (dateAndTime translateTo: dates any offset)! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:13'!
diveInEvent: aDiveInEvent 
	^ self infoAt: #diveInEvent put: aDiveInEvent.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:15'!
diveInLevel
	^ self parentEvent 
		ifNotNil: [ :obj | obj diveInLevel + 1 ]
		ifNil: [ 1 ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:35'!
elementNamePrintOn: aStream
	self elementName 
		ifNil: [ aStream nextPutAll: 'unknown element' ];
		ifNotNil: [ aStream nextPutAll: 'an element' ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:44'!
eventAnalysisPrintOn: aStream
	self printOn: aStream! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:50'!
eventTypePrintOn: aStream
	self eventType
		ifNotNil: [ :aSymbol |
			aStream
				cr;
				print: aSymbol;
				nextPutAll: ' event' ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 22:50'!
followingDifferentTime
	^ self infoAt: #followingDifferentTime ifAbsent: [ self dateAndTimeWithFixedTimeZone ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:35'!
hasElementName
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:46'!
isCategoryDiveIn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:49'!
isElementDiveIn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 16:11'!
isMissStep
	^ self infoAt: #isMissStep ifPresent: [ :obj | true ] ifAbsent: [ false ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:08'!
isRootEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | false ] ifAbsent: [ true ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 10:37'!
isSpotterEvent
	^ true! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:30'!
isStrange
	^ self infoAt: #strange ifPresent: [ :aCol | aCol notEmpty ] ifAbsent: [ false ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:44'!
markAsStrange: aString
	| stranges |
	stranges := self infoAt: #strange ifAbsentPut: [ OrderedCollection new ].
	stranges add: aString.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:36'!
myPositionAmongSameTimeEvents
	^ self infoAt: #myPositionAmongSameTimeEvents ifAbsent: [ 1 ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/11/2015 17:58'!
offset: aDuration 
	"Private: For test case purpose only."
	timestamp := timestamp + aDuration! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:13'!
parentEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | obj ] ifAbsent: [ nil ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition
	^ self infoAt: #relativeXPosition! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition: aDateAndTime 
	^ self infoAt: #relativeXPosition put: aDateAndTime! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:20'!
removeDiveInEvent
	^ self removeInfoKey: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:26'!
removeIsMissStep
	^ self removeInfoKey: #isMissStep! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:22'!
removeSameLevelEvents
	^ self removeInfoKey: #sameLevelEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:26'!
removeSameTimeEvents
	self removeInfoKey: #sameTimeEvents.
	self removeInfoKey: #myPositionAmongSameTimeEvents.
	self removeInfoKey: #followingDifferentTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedCategoryEvent
	^ self removeInfoKey: #selectedCategoryEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedElementEvents
	^ self removeInfoKey: #selectedElementEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:59'!
removeSession
	^ self removeInfoKey: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:24'!
removeStrange
	^ self removeInfoKey: #strange! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:18'!
sameTimeEvents
	^ self infoAt: #sameTimeEvents ifAbsent: [ #() ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:16'!
sameTimeEvents: aCollection index: anInteger nextDateAndTime: aDateAndTime 
	self infoAt: #sameTimeEvents put: aCollection.
	self infoAt: #myPositionAmongSameTimeEvents put: anInteger.
	self infoAt: #followingDifferentTime put: aDateAndTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:02'!
session
	^ self infoAt: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:00'!
session: aSessionCollection 
	^ self infoAt: #session put: aSessionCollection.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:43'!
setMissStep
	^ self infoAt: #isMissStep put: true! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:50'!
strange
	^ self infoAt: #strange ifAbsent: [ #() ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:41'!
userQueryOrSelectionHashes
	"It returns array of hashes that represent user input (query) or user selections."
	^ #()! !

RTTimeLineEntry subclass: #GTATimeLineEntry
	instanceVariableNames: 'computer group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTATimeLineEntry methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 09:58'!
computer
	^ computer! !

!GTATimeLineEntry methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 09:58'!
computer: anObject
	computer := anObject! !

!GTATimeLineEntry methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 09:58'!
group
	^ group! !

!GTATimeLineEntry methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 09:58'!
group: anObject
	group := anObject! !

!GTATimeLineEntry methodsFor: 'printing' stamp: 'JurajKubelka 5/12/2015 10:31'!
humanReadablePrintString
	"Return a String with a human readable representation of me"
	^ String streamContents: [ :out | 
		self printHumanReadableOn: out ]! !

!GTATimeLineEntry methodsFor: 'printing' stamp: 'JurajKubelka 5/12/2015 10:30'!
printHumanReadableOn: aStream
	self group printHumanReadableOn: aStream! !

!GTATimeLineEntry methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 15:30'!
startUnixTime
	^ self group start asUnixTime! !

!RTTimeLineEntry methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/15/2015 09:51'!
humanReadablePrintString
	^ self model humanReadablePrintString! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:15'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:34'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTSpotterEventIcons diveInCategoryIcon ]
			ifTrue: [ GTSpotterEventIcons diveInCategoryMissStepIcon ]! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:24'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 17:26'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream nextPutAll: 'Dive In Category for '.
	aStream 
		print: self duration;
		nextPutAll: ': '.
	self categoryTitle
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString | 
			aStream nextPutAll: aString ].
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:46'!
isCategoryDiveIn
	^ true! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:56'!
event
	self shape: GTAIconBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	self shape: GTAFlexibleResultIconBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:56'!
oblique
	self shape: GTAIconBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:57'!
orthogonal
	self shape: GTAOrthogonalIconBuilder new! !

Announcement subclass: #GTACollectionAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTAItemAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTAItemRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTASaved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:24'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:35'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTSpotterEventIcons diveInElementIcon ]
			ifTrue: [ GTSpotterEventIcons diveInElementMissStepIcon ]! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:25'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 17:25'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream nextPutAll: 'Dive In Element for '.
	aStream 
		print: self duration;
		nextPutAll: ': '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:49'!
isElementDiveIn
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:46'!
analysisIcon
	^ GTSpotterEventIcons exitIcon! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:05'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Close Spotter'! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:44'!
analysisIcon
	^ GTSpotterEventIcons contextChangedIcon! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:57'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Context Change: '.
	self currentTextSizes 
			ifEmpty: [ aStream nextPutAll: 'no input' ]
			ifNotEmpty: [ :aCollection | 
					aStream
						print: aCollection size;
						nextPutAll: (aCollection size = 1 
											ifTrue: [ ' word of size ' ] 
											ifFalse: [ ' words, each of size: ' ]).
				aCollection 
					do: [ :eachSize | aStream print: eachSize ] 
					separatedBy: [ aStream space ].
				self hasCurrentTextSpecials ifTrue: [ 
					aStream nextPutAll: ', with #keyword' ] ]! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isContextChanged! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:41'!
userQueryOrSelectionHashes
	^ self currentTextHashes ! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:41'!
analysisIcon
	^ GTSpotterEventIcons diveOutIcon! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:22'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Dive Out: '.
	self elementNamePrintOn: aStream.
! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!TRCompositeShape methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 23:07'!
allVisibleColor: aColor
	self shapes do: [ :aShape | aShape allVisibleColor: aColor ]! !

!TRShape methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 23:06'!
allVisibleColor: aColor
	self color = Color transparent 
			ifFalse: [ self color: aColor ]! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:37'!
analysisIcon
	^ GTSpotterEventIcons showPreviewIcon! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Show Preview'! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:55'!
isForTimelineView
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:47'!
analysisIcon
	^ GTSpotterEventIcons actOnIcon! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 17:26'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Act On: '.
	self elementNamePrintOn: aStream.
	self eventTypePrintOn: aStream.! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:48'!
currentQueryHashes
	^ self stringHashesFor: self query! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:36'!
currentQuerySizes
	^ self stringSizesFor: self query! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 16:41'!
eventAnalysisPrintOn: aStream
	| categories | 
	categories := self notEmptyCategories.
	aStream
		nextPutAll: 'SearchFinished: ';
		nextPutAll: (query ifNil: [ 'no query' ] ifNotNil: [ 'with query' ]);
		nextPutAll: ', ';
		print: categories size;
		nextPutAll: ' categories, ';
		print: (self items ifEmpty: [ 0 ] ifNotEmpty: [ :col | col sum ]);
		nextPutAll: ' findings'.
	categories ifNotEmpty: [ | index |
		index := 1.
		aStream cr.
		categories 
			do: [ :category |
				index \\ 6 = 0 ifTrue: [ aStream cr ].
				aStream 
					nextPutAll: category key;
					nextPutAll: ' (';
					print: category value;
					nextPut: $).
				index := index + 1.
				 ] 
			separatedBy: [ aStream nextPutAll: ', ' ] ].
! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 15:27'!
isForTimelineView
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 16:29'!
notEmptyCategories
	| notEmptyCategories |
	notEmptyCategories := OrderedCollection new.
	self processors ifNil: [ notEmptyCategories ].
	self processors pairsDo: [ :processor :items |
		items > 0 ifTrue: [ notEmptyCategories add: (processor -> items) ]
	].
	^ notEmptyCategories! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:49'!
userQueryOrSelectionHashes
	^ self currentQueryHashes! !

!GTSpotterRecorderOpenEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Open Spotter'! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 12:45'!
analysisIcon
	^ GTSpotterEventIcons selectedCandidateChangedIcon! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:50'!
categoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:50'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Selection of '.
	self elementNamePrintOn: aStream.
	self selectedCategoryLabel ifNotNil: [ :aLabelString |
		aStream
			cr
			nextPutAll: 'in category ';
			nextPutAll: aLabelString ].
	self eventTypePrintOn: aStream.
! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 15:40'!
existsUserSelectionsOfTheSameElement
	| index |
	index := self session identityIndexOf: self.
	^ self session anySatisfy: [ :each | 
			((each isUserSelectionClass and: [ 
				each elementName = self elementName ]) 
					and: [ (each == self) not ]) 
						and: [ (self session identityIndexOf: each) < index ] ] ! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isUserSelection! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:42'!
isInTheSameCategoryAsPreviousSelection
	^ self selectedCategoryLabel = self previousSelection selectedCategoryLabel! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:38'!
previousSelection
	^ self infoAt: #previousSelection ifAbsent: [ nil ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:37'!
previousSelection: aGTSpotterRecorderSelectedCandidateChangedEvent 
	self infoAt: #previousSelection put: aGTSpotterRecorderSelectedCandidateChangedEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:38'!
removePreviousSelection
	^ self removeInfoKey: #previousSelection! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:06'!
selectedCategoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:48'!
selectedCategoryEvent: anEvent
	self infoAt: #selectedCategoryEvent put: anEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:07'!
selectedCategoryLabel
	^ self selectedCategoryEvent ifNotNil: [ :catEvent | catEvent categoryLabel ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 16:06'!
userSelectionsOfTheSameElement
	| index |
	index := self session identityIndexOf: self.
	^ self session select: [ :each | 
			((each isUserSelectionClass and: [ 
				each elementName = self elementName ]) 
					and: [ (each == self) not ]) 
						and: [ (self session identityIndexOf: each) < index ] ] ! !

TestCase subclass: #GTAIconBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTAIconBuilderTest commentStamp: '<historical>' prior: 0!
A GTATimelineIconBuilderTest is a test class for testing the behavior of GTATimelineIconBuilder!

!GTAIconBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/19/2015 13:56'!
setUp
	super setUp.
	builder := GTAIconBuilder new.
	! !

!GTAIconBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 4/11/2015 20:05'!
testShapeFor
	| shape view |
	view := RTView new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		shape := builder shapeFor: eachClass new.
		shape ifNotNil: [
			view add: shape element ]
	].
	RTHorizontalLineLayout on: view elements.
	view! !

TestCase subclass: #GTARoughDataSetBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTARoughDataSetBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:20'!
dateAndTimes
	^ OrderedCollection new
		add: (DateAndTime year: 2015 month: 01 day: 02);
		add: (DateAndTime year: 2015 month: 01 day: 03);
		add: (DateAndTime year: 2015 month: 01 day: 05);
		add: (DateAndTime year: 2015 month: 01 day: 14);
		add: (DateAndTime year: 2015 month: 02 day: 07);
		add: (DateAndTime year: 2015 month: 02 day: 10);
		add: (DateAndTime year: 2015 month: 02 day: 15);
		add: (DateAndTime year: 2015 month: 03 day: 30);
		yourself! !

!GTARoughDataSetBuilderTest methodsFor: 'private' stamp: 'JurajKubelka 5/11/2015 17:30'!
session: aCollection offset: aDuration 
	aCollection do: [ :eachEvent |
		eachEvent offset: aDuration
	 ].
	^ aCollection! !

!GTARoughDataSetBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:29'!
sessions
	^ OrderedCollection new
		add: (self session: GTASessionExamples session1 offset: -30 days);
		add: (self session: GTASessionExamples session1 offset: -28 days);
		add: (self session: GTASessionExamples session1 offset: -15 days);
		add: (self session: GTASessionExamples session1 offset: -5 days);
		add: (self session: GTASessionExamples session1 offset: -1 days);
		yourself! !

!GTARoughDataSetBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 5/11/2015 16:47'!
setUp
	super setUp.
	builder := GTARoughDataSetBuilder new.! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 18:14'!
testBuild
	| objects |
	objects := #(0 1 2 3   13 15 17   23   29 30).
	builder
		objects: objects;
		gap: 5;
		build.
	self assert: builder numberOfGroups equals: 4.
	self assert: builder groups first size equals: 4.
	self assert: builder groups second size equals: 3.
	self assert: builder groups third size equals: 1.
	self assert: builder groups fourth size equals: 2.
	self assert: builder groups first asArray equals: #(0 1 2 3).
	self assert: builder groups second asArray equals: #(13 15 17).
	self assert: builder groups third asArray equals: #(23).
	self assert: builder groups fourth asArray equals: #(29 30).! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 18:14'!
testBuildDateAndTimes
	| objects |
	objects := self dateAndTimes.
	builder
		objects: objects;
		gap: 2 weeks;
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 4.
	self assert: builder groups second size equals: 3.
	self assert: builder groups third size equals: 1.
! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/14/2015 17:49'!
testBuildSessions
	| objects |
	objects := self sessions.
	builder
		objects: objects;
		gap: 1 week;
		setSessionComparator;
		groupClass: GTASomeSessions;
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 2.
	self assert: builder groups second size equals: 1.
	self assert: builder groups third size equals: 2.
	self assert: (builder groups allSatisfy: [ :eachGroup | eachGroup class = GTASomeSessions ]).
! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/14/2015 17:59'!
testBuildSessions2
	| objects |
	objects := self sessions.
	builder
		objects: objects;
		gap: 1 week;
		setSessionComparator;
		newGroupBlock: [ GTASomeSessions new ];
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 2.
	self assert: builder groups second size equals: 1.
	self assert: builder groups third size equals: 2.
	self assert: (builder groups allSatisfy: [ :eachGroup | eachGroup class = GTASomeSessions ]).
! !

TestCase subclass: #GTATimelineBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTATimelineBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:42'!
session1
	^ GTASessionExamples session1! !

!GTATimelineBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 4/13/2015 17:42'!
setUp
	super setUp.
	builder := GTATimelineBuilder new.! !

!GTATimelineBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 16:11'!
testBuild
	| events |
	events := GTASession new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		events add: eachClass new.
	].
	builder events: events.
	builder build.
	builder view.! !

!GTATimelineBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 4/13/2015 17:43'!
testBuildSession1
	| events |
	events := self session1.
	builder
		events: events;
		analyze;
		withEdges.
	builder interaction 
		popupText: #asEventAnalysisString;
		draggable.
	builder build.
	"builder view inspect."! !

TestCase subclass: #GTSpotterPrintDateAndTimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterPrintDateAndTimeTest commentStamp: '<historical>' prior: 0!
A GTSpotterPrintDateAndTimeTest is a test class for testing the behavior of GTSpotterPrintDateAndTime!

!GTSpotterPrintDateAndTimeTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 13:44'!
testUCTPlus1
	| dateAndTime string |
	dateAndTime := '2015-03-27T14:59:05.524852+01:00' asDateAndTime.
	string := GTSpotterPrintDateAndTime yyyyMmDdAndHhMmSs: dateAndTime.
	self assert: string equals: '2015-03-27, 13:59:05'.! !

TestCase subclass: #GTSpotterSessionAnalysisTest
	instanceVariableNames: 'analysis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterSessionAnalysisTest commentStamp: '<historical>' prior: 0!
A GTSpotterDiveInLevelCommandTest is a test class for testing the behavior of GTSpotterDiveInLevelCommand!

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session1
	^ GTASessionExamples session1! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session2
	^ GTASessionExamples session2! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session3
	^ GTASessionExamples session3! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:55'!
session4
	^ GTASessionExamples session4! !

!GTSpotterSessionAnalysisTest methodsFor: 'running' stamp: 'JurajKubelka 3/31/2015 13:24'!
setUp
	super setUp.
	analysis := GTSpotterSessionAnalysis new.
	! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/12/2015 13:58'!
testCategoriesSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: (session at: 4) categoryEvent equals: (session at: 5).
	self assert: (session at: 5) elementSelectionEvents size equals: 3.
	self assert: (session at: 5) elementSelectionEvents first equals: (session at: 4).
	self assert: (session at: 5) elementSelectionEvents second equals: (session at: 7).
	self assert: (session at: 5) elementSelectionEvents third equals: (session at: 8).
	self assert: (session at: 9) categoryEvent equals: (session at: 10).
	self assert: (session at: 10) elementSelectionEvents size equals: 1.
	self assert: (session at: 10) elementSelectionEvents first equals: (session at: 9).
! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/12/2015 14:14'!
testCategoriesSession4
	| session |
	analysis session: self session4.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 20.
	self assert: (session at: 4) categoryEvent equals: (session at: 5).
	self assert: (session at: 7) categoryEvent equals: (session at: 5).
	self assert: (session at: 8) categoryEvent equals: (session at: 9).
	self assert: (session at: 12) categoryEvent equals: (session at: 9).
	self assert: (session at: 13) categoryEvent equals: (session at: 14).
	self assert: (session at: 16) categoryEvent equals: (session at: 14).
	self assert: (session at: 17) categoryEvent equals: (session at: 14).
	self assert: (session at: 18) categoryEvent equals: (session at: 14).
	self assert: (session at: 19) categoryEvent equals: (session at: 14).

	self assert: (session at: 5) elementSelectionEvents size equals: 2.
	self assert: (session at: 9) elementSelectionEvents size equals: 2.
	self assert: (session at: 14) elementSelectionEvents size equals: 5.

	self assert: (session at: 5) elementSelectionEvents first equals: (session at: 4).
	self assert: (session at: 5) elementSelectionEvents second equals: (session at: 7).

	self assert: (session at: 9) elementSelectionEvents first equals: (session at: 8).
	self assert: (session at: 9) elementSelectionEvents second equals: (session at: 12).

	self assert: (session at: 14) elementSelectionEvents first equals: (session at: 13).
	self assert: (session at: 14) elementSelectionEvents second equals: (session at: 16).
	self assert: (session at: 14) elementSelectionEvents third equals: (session at: 17).
	self assert: (session at: 14) elementSelectionEvents fourth equals: (session at: 18).
	self assert: (session at: 14) elementSelectionEvents fifth equals: (session at: 19).
! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:28'!
testMissStepsSession1
	| session |
	analysis session: self session1.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 27.
	self assert: session numberOfMissSteps equals: 1.
	self assert: (session at: 6) isMissStep.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:29'!
testMissStepsSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: session numberOfMissSteps equals: 0.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:04'!
testMissStepsSession3
	| session |
	analysis session: self session3.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 20.
	self assert: (session at: 9) isMissStep.
	self deny: (session at: 16) isMissStep.
	self assert: session numberOfMissSteps equals: 1.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 3/31/2015 13:41'!
testRootsSession1
	| roots |
	analysis session: self session1.
	analysis execute.
	roots := analysis session roots.
	self assert: roots size equals: 11.
	self assert: (roots at: 6) children size equals: 4.
	self assert: (roots at: 1) children size equals: 0.
	self assert: (roots at: 7) children size equals: 8.
	self assert: ((roots at: 7) children at: 4) children size equals: 4.
! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:38'!
analysisIcon
	^ GTSpotterEventIcons hidePreviewIcon! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:56'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Hide Preview'! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:51'!
elementSelectionEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:04'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Category: '.
	self categoryLabel
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString |
			aStream 
				nextPutAll: aString;
				nextPutAll: ' with ';
				print: self elementCountOrZero;
				nextPutAll: ' spotted and ';
				print: self selectedElementEvents size;
				nextPutAll: ' selected elements' ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:40'!
markAsStrange
	^ self infoAt: #strange put: true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:42'!
selectedElementEvent: anEvent
	| elements |
	elements := self infoAt: #selectedElementEvents ifAbsentPut: [ OrderedCollection new ].
	elements add: anEvent! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:02'!
selectedElementEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

RTHorizontalLineLayout subclass: #GTAHorizontalDivingLineLayout
	instanceVariableNames: 'diveInLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 16:35'!
diveElement: eachElement
	^ (self diveInLevel cull: eachElement cull: self)
 			* self diveStep! !

!GTAHorizontalDivingLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/14/2015 12:33'!
diveElements: elements
	elements do: [ :eachElement | eachElement translateBy: 0 @ (self diveElement: eachElement) ]! !

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 16:37'!
diveInLevel
	^ diveInLevel ifNil: [ diveInLevel := self newDiveInLevel ]! !

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/17/2015 11:48'!
diveStep
	^ 5! !

!GTAHorizontalDivingLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/17/2015 10:11'!
doExecute: elements
	super doExecute: elements.
	self diveElements: elements! !

!GTAHorizontalDivingLineLayout methodsFor: 'initialize-release' stamp: 'JurajKubelka 4/17/2015 14:53'!
initialize
	super initialize.
	horizontalGap := 2.
	self alignCenter.! !

!GTAHorizontalDivingLineLayout methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 16:38'!
newDiveInLevel
	^ [ :element | #diveInLevel cull: element model ]! !

GTAHorizontalDivingLineLayout subclass: #GTAHorizontalRealTimelineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTAHorizontalRealTimelineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/17/2015 15:54'!
doExecute: elements
	| offset previousElement right left min minTime maxTime duration max |
	min := elements detectMin: [ :each | each position x ].
	elements do: [ :each | each translateTo: (min position x) @ (each position y) ].
	minTime := (elements detectMin: [ :each | each model dateAndTimeWithFixedTimeZone ]) model dateAndTimeWithFixedTimeZone.
	maxTime := (elements detectMax: [ :each | each model dateAndTimeWithFixedTimeZone ]) model dateAndTimeWithFixedTimeZone.
	duration := maxTime  - minTime.
	duration = 0 seconds
		ifTrue: [ max := 500 ]
		ifFalse: [ max := duration seconds * 8 ].
	RTMetricNormalizer new
		elements: elements;
		normalizeX: [ :eachEvent | self xFor: eachEvent ] min: 0 max: max.
	self diveElements: elements.
	previousElement := elements first.
	offset := 0.
	elements allButFirstDo: [ :element |
		right := previousElement encompassingRectangle right.
		left := element encompassingRectangle left.
		right > left
			ifTrue: [ offset := (right - left) rounded + 3 ]
			"ifFalse: [ offset := 0 ]".
		element translateBy: (offset @ 0).
		previousElement := element.
	 ].! !

!GTAHorizontalRealTimelineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 12:34'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

Object subclass: #GTABookmark
	instanceVariableNames: 'item description dateAndTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:30'!
dateAndTime
	^ dateAndTime! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:30'!
dateAndTime: anObject
	dateAndTime := anObject! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:25'!
description
	^ description! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:25'!
description: anObject
	description := anObject! !

!GTABookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/13/2015 19:51'!
from: aCollection computers: aGTAComputers 
	self subclassResponsibility! !

!GTABookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/13/2015 16:31'!
initialize
	super initialize.
	dateAndTime := DateAndTime now.! !

!GTABookmark methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:59'!
isRelatedTo: anObject 
	^ self item = anObject ! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:29'!
item
	^ item! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:29'!
item: anObject
	item := anObject! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:35'!
path
	^ self subclassResponsibility.! !

GTABookmark subclass: #GTAComputerBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTAComputerBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 12:49'!
from: aCollection computers: aGTAComputers 
	| computer |
	computer := aGTAComputers detect: [ :each | each computerUUID = aCollection second ].
	self
		item: computer;
		description: aCollection third;
		dateAndTime: aCollection fourth.! !

!GTAComputerBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 12:25'!
path
	^ Array
		with: self class
		with: self item computerUUID
		with: self description
		with: self dateAndTime! !

GTABookmark subclass: #GTASessionBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTASessionBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/13/2015 18:24'!
from: aCollection computers: aGTAComputers 
	| computer session |
	computer := aGTAComputers detect: [ :each | each computerUUID = aCollection second ].
	session := computer detect: [ :each | each start = aCollection third ].
	self
		item: session;
		description: aCollection fourth;
		dateAndTime: aCollection fifth.! !

!GTASessionBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:37'!
path
	^ Array
		with: self class
		with: self item computerUUID
		with: self item start
		with: self description
		with: self dateAndTime! !

Object subclass: #GTAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTAConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 11:01'!
developerUUIDs
	"
	GTSpotterEventRecorderSettings ensureComputerID.
	GTSpotterEventRecorderSettings uniqueInstance computerUUID.
	"
	^ #( 	'58d42da6-c993-4ad1-8624-5fd628793610' 
			'8c7d33b4-1025-42b3-8dc4-4a2bb32c5a42'
			'4483f704-6909-45d7-9367-869a5850c3e8'
			'52fe7c39-9c98-4fa7-a883-a8b2cabe84db'
			'69202c73-b32f-4968-aaf1-0666d421ea57'
			'0cd69f50-ad08-8c47-84ec-329e2210a2f2'
		)! !

!GTAConfiguration class methodsFor: 'testing' stamp: 'JurajKubelka 5/13/2015 11:01'!
isDeveloper: anUUID
	^ self developerUUIDs includes: anUUID asString! !

!GTAConfiguration class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 18:13'!
loadBookmarks: aGTAComputers
	^ GTABookmarks from: self savedBookmarks computers: aGTAComputers! !

!GTAConfiguration class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 18:28'!
saveBookmarks: aGTABookmarks
	| paths methodSource |
	paths := aGTABookmarks collect: [ :each | each path ] as: Array.
	methodSource := String streamContents: [ :aStream |
		aStream
			nextPutAll: 'savedBookmarks'; cr; 
			tab; nextPutAll: '"Automatically created by class method #saveBookmarks."'; cr;
			tab; nextPutAll: '^ '.
		paths storeOn: aStream. 			
	 ].
	self class compile: methodSource classified: 'stored bookmarks'.! !

!GTAConfiguration class methodsFor: 'stored bookmarks' stamp: 'JurajKubelka 5/14/2015 15:38'!
savedBookmarks
	"Automatically created by class method #saveBookmarks."
	^ ((Array new: 9) at: 1 put: ((Array new: 5) at: 1 put: GTASessionBookmark; at: 2 put: '29d8c44d-c6da-4026-bf49-c3b0c25625db'; at: 3 put: (DateAndTime basicNew instVarAt: 1 put: 72594; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2457117; instVarAt: 4 put: 0; yourself); at: 4 put: 'History and calculator results'; at: 5 put: (DateAndTime basicNew instVarAt: 1 put: 70290; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457156; instVarAt: 4 put: 682694000; yourself); yourself); at: 2 put: ((Array new: 5) at: 1 put: GTASessionBookmark; at: 2 put: '5ce39222-e2e9-441a-b877-d3ca84be5d75'; at: 3 put: (DateAndTime basicNew instVarAt: 1 put: 70406; instVarAt: 2 put: (Duration seconds: 3600 nanoSeconds: 0); instVarAt: 3 put: 2457099; instVarAt: 4 put: 0; yourself); at: 4 put: 'Remove this kind of sessions, because user only opens and closes Spotter.
No reason to keep it.'; at: 5 put: (DateAndTime basicNew instVarAt: 1 put: 49356; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 347933000; yourself); yourself); at: 3 put: ((Array new: 4) at: 1 put: GTAComputerBookmark; at: 2 put: '5ce39222-e2e9-441a-b877-d3ca84be5d75'; at: 3 put: 'We should remove sessions with unknown elements in dive-in, in act-on, etc.'; at: 4 put: (DateAndTime basicNew instVarAt: 1 put: 55511; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 197500000; yourself); yourself); at: 4 put: ((Array new: 4) at: 1 put: GTAComputerBookmark; at: 2 put: '8cafe0a2-c35e-43c8-a945-3fb323f3bfb8'; at: 3 put: 'It uses dives-in and several categories.'; at: 4 put: (DateAndTime basicNew instVarAt: 1 put: 56543; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 84485000; yourself); yourself); at: 5 put: ((Array new: 5) at: 1 put: GTASessionBookmark; at: 2 put: 'b077896a-af9a-4364-b59a-8fab094f8f98'; at: 3 put: (DateAndTime basicNew instVarAt: 1 put: 58242; instVarAt: 2 put: (Duration seconds: -25200 nanoSeconds: 0); instVarAt: 3 put: 2457145; instVarAt: 4 put: 873372000; yourself); at: 4 put: 'Remove such sessions. It is only opened and closed.'; at: 5 put: (DateAndTime basicNew instVarAt: 1 put: 56747; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 332268000; yourself); yourself); at: 6 put: ((Array new: 5) at: 1 put: GTASessionBookmark; at: 2 put: '29d8c44d-c6da-4026-bf49-c3b0c25625db'; at: 3 put: (DateAndTime basicNew instVarAt: 1 put: 46260; instVarAt: 2 put: (Duration seconds: 3600 nanoSeconds: 0); instVarAt: 3 put: 2457101; instVarAt: 4 put: 0; yourself); at: 4 put: 'Remove it, there are only preview on/off.'; at: 5 put: (DateAndTime basicNew instVarAt: 1 put: 66326; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 834319000; yourself); yourself); at: 7 put: ((Array new: 5) at: 1 put: GTASessionBookmark; at: 2 put: '29d8c44d-c6da-4026-bf49-c3b0c25625db'; at: 3 put: (DateAndTime basicNew instVarAt: 1 put: 46295; instVarAt: 2 put: (Duration seconds: 3600 nanoSeconds: 0); instVarAt: 3 put: 2457101; instVarAt: 4 put: 0; yourself); at: 4 put: 'Remove it, there are only preview on/off.'; at: 5 put: (DateAndTime basicNew instVarAt: 1 put: 66379; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 289678000; yourself); yourself); at: 8 put: ((Array new: 5) at: 1 put: GTASessionBookmark; at: 2 put: '29d8c44d-c6da-4026-bf49-c3b0c25625db'; at: 3 put: (DateAndTime basicNew instVarAt: 1 put: 58917; instVarAt: 2 put: (Duration seconds: 3600 nanoSeconds: 0); instVarAt: 3 put: 2457103; instVarAt: 4 put: 0; yourself); at: 4 put: 'It is a simplest example of using spotter: It reuse the first item in category called History.'; at: 5 put: (DateAndTime basicNew instVarAt: 1 put: 66651; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 665799000; yourself); yourself); at: 9 put: ((Array new: 4) at: 1 put: GTAComputerBookmark; at: 2 put: '29d8c44d-c6da-4026-bf49-c3b0c25625db'; at: 3 put: 'A lot of categories are browsed.'; at: 4 put: (DateAndTime basicNew instVarAt: 1 put: 67093; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2457157; instVarAt: 4 put: 55077000; yourself); yourself); yourself)! !

Object subclass: #GTADateAndTimeStringBuilder
	instanceVariableNames: 'dateAndTime duration numberOfLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
dateAndTime
	^ dateAndTime! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
dateAndTime: anObject
	dateAndTime := anObject! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
duration
	^ duration! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
duration: anObject
	duration := anObject! !

!GTADateAndTimeStringBuilder methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/14/2015 18:44'!
humanReadablePrintString
	self duration days > self numberOfLabels ifTrue: [ ^ self dateAndTime asDate printString ].
	self duration days > 1 ifTrue: [ ^ String streamContents: [ :aStream | 
			self dateAndTime printSeparateDateAndTimeOn: aStream ] ]. 
	self duration minutes > self numberOfLabels ifTrue: [ ^ self dateAndTime asTime print24 ].
	self duration minutes > 1 ifTrue: [ ^ String streamContents: [ :aStream | 
			self dateAndTime printMSOn: aStream ] ].
	^ self dateAndTime asSeconds printString! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:24'!
numberOfLabels
	^ numberOfLabels! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:24'!
numberOfLabels: anObject
	numberOfLabels := anObject! !

Object subclass: #GTADefaultTimelineConfiguration
	instanceVariableNames: 'lastBuilder withEdges layout shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

GTADefaultTimelineConfiguration class
	instanceVariableNames: 'uniqueInstance'!

GTADefaultTimelineConfiguration class
	instanceVariableNames: 'uniqueInstance'!

!GTADefaultTimelineConfiguration class methodsFor: 'cleanup' stamp: 'JurajKubelka 4/15/2015 16:10'!
cleanUp
	self reset.! !

!GTADefaultTimelineConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:09'!
reset
	"self reset"
	uniqueInstance := nil! !

!GTADefaultTimelineConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:52'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'api' stamp: 'JurajKubelka 4/17/2015 11:32'!
configure: builder 
	builder
		withEdges: self withEdges;
		layout: self layout.
	builder shape shape: self shape.
	builder interaction
		popupText: #asEventAnalysisString;
		draggable.
	builder interaction showEdge
		connectTo: [ :event | 
			event isUserSelection
				ifFalse: [ RTGroup new ]
				ifTrue: [ 
					builder view elements
						select: [ :eachElement | eachElement model isSpotterEvent
								and: [ eachElement model isUserSelection
								and: [ eachElement model elementName = event elementName ] ] ]
						thenCollect: #model ] ];
		shape: [ :el | RTLine new color: (Color blue alpha: 0.4) ] ! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:56'!
layout
	^ layout ifNil: [ layout := GTAHorizontalDivingLineLayout new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:04'!
layout: aLayout 
	layout := aLayout! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/19/2015 13:57'!
shape
	^ shape ifNil: [ shape := GTAOrthogonalIconBuilder new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:05'!
shape: aShape 
	shape := aShape! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/17/2015 14:32'!
withEdges
	^ withEdges ifNil: [ withEdges := false ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:05'!
withEdges: aBoolean 
	withEdges := aBoolean! !

Object subclass: #GTAIconBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHalfHeight
	^ 5! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHeight
	^ 10! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultMinHeight
	^ 2! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultMinWidth
	^ 1! !

!GTAIconBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultWidth
	^ 10! !

!GTAIconBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/13/2015 17:00'!
elementOn: aModel 
	^ (self shapeFor: aModel) elementOn: aModel! !

!GTAIconBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/13/2015 16:58'!
elementsOn: models
	^ models collect: [ :eachModel | (self elementOn: eachModel) ] as: RTGroup! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/19/2015 13:35'!
newContextChangedForOneWordEvent: aGTSpotterEvent
	| shape sizes |
	shape := RTBox new height: self defaultHeight; width: self defaultMinWidth; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	(sizes notNil and: [ sizes notEmpty ]) ifTrue: [ shape width: sizes sum ].
	aGTSpotterEvent hasCurrentTextSpecials ifTrue: [ shape height: self defaultHalfHeight ]. 
	^ shape! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/19/2015 13:35'!
newContextChangedForSeveralWordsEvent: aGTSpotterEvent
	| composition sizes keywords shapes |
	composition := RTCompositeShape new horizontal; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	keywords := aGTSpotterEvent currentTextSpecials.
	shapes := OrderedCollection new.
	sizes with: keywords do: [ :size :keyword |
		shapes add: (self newShapeForWordOfSize: size keyword: keyword) ].
	shapes 
		do: [ :shape | composition add: shape ]
		separatedBy: [ 
			composition add: (RTBox new height: 1; width: 1; yourself) ].
	^ composition! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 11:40'!
newCorrectDiveInElementEvent: aGTSpotterEvent
	^ RTBox new
		height: 2;
		width: 5;
		yourself! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 11:45'!
newMissStepDiveInElementEvent: aGTSpotterEvent 
	| s1 s3 s2 c |
	c := RTCompositeShape new.
	s1 := RTBox new
				height: 2;
				width: 2;
				yourself.
	s2 := RTBox new
				height: 2;
				width: 1;
				color: Color transparent;
				yourself.
	s3 := RTBox new
				height: 2;
				width: 2;
				yourself.
	c add: s1; add: s2; add: s3; horizontal.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:33'!
newSearchFinishedForOneCategoryEvent: aGTSpotterEvent
	| size sizes shapeAndSize |
	sizes := aGTSpotterEvent items.
	(sizes notNil and: [ sizes notEmpty ]) 
		ifTrue: [ size := sizes sum ]
		ifFalse: [ size := 1 ].
	shapeAndSize := self newShapeForQueryOfSize: size.
	^ shapeAndSize key! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:32'!
newSearchFinishedForSeveralCategoriesEvent: aGTSpotterEvent
	| composition categoriesAndItems offset |
	composition := RTCompositeShape new.
	categoriesAndItems := aGTSpotterEvent notEmptyCategories.
	offset := 0.
	categoriesAndItems 
		do: [ :categoryAndItems | | shapeAndSize size |
			size := categoryAndItems value.
			shapeAndSize := self newShapeForQueryOfSize: size.
			composition add: shapeAndSize key translateBy: offset @ 0.
			offset := offset + shapeAndSize value ]
		separatedBy: [ | connector |
			connector := RTCompositeShape new.
			connector 
				add: (RTBox new height: 1; width: 1; yourself);
				add: (RTBox new height: 1; width: 1; yourself)
					translateBy: 0 @ 6.
			composition 
				add: connector
				translateBy: offset @ 0.
				offset := offset + 2 ].
	^ composition! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:31'!
newShapeForQueryOfSize: wordSize
	| s1 s3 c size |
	size := wordSize // 10.
	size < 2 ifTrue: [ size := 2 ].
	size > 100 ifTrue: [ size := 100 ].
	c := RTCompositeShape new.
	s1 := RTBox new height: 4; width: size; yourself.
	s3 := RTBox new height: 4; width: size; yourself.	
	c 
		add: s1;
		add: s3 translateBy: 0 @ 6.
	^ c -> size! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:41'!
newShapeForSelectionEventKeyArrowDown: aGTSpotterEvent 
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownDifferentCategory: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:48'!
newShapeForSelectionEventKeyArrowDownDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownDifferentCategoryUnique: aGTSpotterEvent  ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:58'!
newShapeForSelectionEventKeyArrowDownDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s2 translateBy: 0 @ 7; 
		add: s1 translateBy: 0 @ 12.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:36'!
newShapeForSelectionEventKeyArrowDownDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s1 translateBy: 0 @ 7; 
		add: s2 translateBy: 0 @ 12.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:36'!
newShapeForSelectionEventKeyArrowDownSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownSameCategoryUnique: aGTSpotterEvent  ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:08'!
newShapeForSelectionEventKeyArrowDownSameCategoryRepetition: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:11'!
newShapeForSelectionEventKeyArrowDownSameCategoryUnique: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:41'!
newShapeForSelectionEventKeyArrowUp: aGTSpotterEvent
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpDifferentCategory: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:53'!
newShapeForSelectionEventKeyArrowUpDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpDifferentCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:01'!
newShapeForSelectionEventKeyArrowUpDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1;
		add: s2 translateBy: 0 @ 5; 
		add: s3 translateBy: 0 @ 13.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:03'!
newShapeForSelectionEventKeyArrowUpDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1;
		add: s2 translateBy: 0 @ 5; 
		add: s3 translateBy: 0 @ 13.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:52'!
newShapeForSelectionEventKeyArrowUpSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpSameCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:30'!
newShapeForSelectionEventKeyArrowUpSameCategoryRepetition: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 9; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:03'!
newShapeForSelectionEventKeyArrowUpSameCategoryUnique: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 6; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:43'!
newShapeForSelectionEventSingleClick: aGTSpotterEvent 
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventSingleClickSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickDifferentCategory: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:59'!
newShapeForSelectionEventSingleClickDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventSingleClickDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickDifferentCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:50'!
newShapeForSelectionEventSingleClickDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 s4 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s3 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s4 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s4 translateBy: 0 @ 5; 
		add: s1 translateBy: 0 @ 10;
		add: s2 translateBy: 0 @ 15.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:47'!
newShapeForSelectionEventSingleClickDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 s4 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s3 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ -5. 5 @ 0 };
				yourself.
	s4 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ -5. 5 @ 0 };
				yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s4 translateBy: 0 @ 5; 
		add: s1 translateBy: 0 @ 10;
		add: s2 translateBy: 0 @ 15.
	^ c! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:56'!
newShapeForSelectionEventSingleClickSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventSingleClickSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickSameCategoryUnique: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:55'!
newShapeForSelectionEventSingleClickSameCategoryRepetition: aGTSpotterEvent 
	^ RTPolygon new 
			vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0. 2 @ 5. -2 @ 5 };
			yourself! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:33'!
newShapeForSelectionEventSingleClickSameCategoryUnique: aGTSpotterEvent 
	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			yourself! !

!GTAIconBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 10:21'!
newShapeForWordOfSize: wordSize keyword: aBoolean
	^ RTBox new 
			height: (aBoolean ifTrue: [ self defaultHalfHeight ] ifFalse: [ self defaultHeight ]); 
			width: wordSize; 
			yourself.! !

!GTAIconBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 16:49'!
shapeFor: aGTSpotterEvent 
	^ aGTSpotterEvent accept: self! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitActOnEvent: aGTSpotterEvent 
	^ RTPolygon new vertices: { -5 @ -5. 5 @ 0. -5 @ 5 }; yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitCategorySelectedEvent: aGTSpotterRecorderCategorySelectedEvent 
	^ nil! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:35'!
visitContextChangedEvent: aGTSpotterEvent 
	^ aGTSpotterEvent currentTextSizes size < 2
		ifTrue: [ self newContextChangedForOneWordEvent: aGTSpotterEvent ]
		ifFalse: [ self newContextChangedForSeveralWordsEvent: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 14:23'!
visitDiveInCategoryEvent: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTBox new height: 2; width: 5; yourself.
	s2 := RTBox new height: 2; width: 5; color: Color transparent; yourself.
	s3 := RTBox new height: 2; width: 5; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; add: s3; vertical.
	^ c! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/14/2015 11:40'!
visitDiveInElementEvent: aGTSpotterEvent 
	^ aGTSpotterEvent isMissStep 
		ifTrue: [ self newMissStepDiveInElementEvent: aGTSpotterEvent ]
		ifFalse: [ self newCorrectDiveInElementEvent: aGTSpotterEvent ]! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 14:24'!
visitDiveOutEvent: aGTSpotterEvent 
	^ RTBox new
		height: 2;
		width: 5;
		yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitExitEvent: aGTSpotterEvent 
	^ RTPolygon new 
		vertices: { 
			-4 @ -5. 0 @ -1. 4 @ -5. 5 @ -4. 1 @ 0. 
			5 @ 4. 4 @ 5. 0 @ 1. -4 @ 5. -5 @ 4. -1 @ 0. -5 @ -4 };
		yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 01:38'!
visitHidePreviewEvent: aGTSpotterEvent 
	^ RTArc new 
			innerRadius: 4;
			externalRadius: 5;
			outerAngle: 0 innerAngle: 360! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitOpenEvent: aGTSpotterRecorderOpenEvent 
	^ nil! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:34'!
visitSearchFinishedEvent: aGTSpotterEvent 
	^ RTPolygon new
			vertices: { -5 @ 0. -3 @ 0. -1 @ 4. 1 @ -3. 3 @ 0. 5 @ 0. 
							5 @ -1. 3 @ -1. 1 @ -4. -1 @ 3. -3 @ -1. -5 @ -1 };
			yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 13:42'!
visitSelectedCandidateChangedEvent: aGTSpotterEvent 
	| type |
	type := aGTSpotterEvent eventType. 
	type = #keyPressedArrowUp ifTrue: [ 
		^ self newShapeForSelectionEventKeyArrowUp: aGTSpotterEvent ].

	type = #keyPressedArrowDown ifTrue: [ 
		^ self newShapeForSelectionEventKeyArrowDown: aGTSpotterEvent ].

	type = #singleClick ifTrue: [ 
		^ self newShapeForSelectionEventSingleClick: aGTSpotterEvent ].

	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			color: Color transparent;
			borderColor: RTPolygon new defaultColor;
			yourself! !

!GTAIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 00:21'!
visitShowPreviewEvent: aGTSpotterEvent 
	^ RTEllipse new size: 10; yourself! !

GTAIconBuilder subclass: #GTAOrthogonalIconBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

GTAOrthogonalIconBuilder subclass: #GTAFlexibleResultIconBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTAFlexibleResultIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:58'!
visitSearchFinishedEvent: aGTSpotterEvent 
	^ aGTSpotterEvent notEmptyCategories size < 2
		ifTrue: [ self newSearchFinishedForOneCategoryEvent: aGTSpotterEvent ]
		ifFalse: [ self newSearchFinishedForSeveralCategoriesEvent: aGTSpotterEvent ]! !

!GTAOrthogonalIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 12:24'!
visitDiveInCategoryEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -3 @ -2. 1 @ -2. 1 @ 4. 3 @ 4. 3 @ 5. 0 @ 5. 0 @ 1. 
								-3 @ 1. -3 @ 0. 0 @ 0. 0 @ -1. -3 @ -1 };
				yourself.
	s2 := RTBox new width: 6; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAOrthogonalIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 12:26'!
visitDiveInElementEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -2 @ -1. 1 @ -1. 1 @ 4. 3 @ 4. 3 @ 5. 0 @ 5. 0 @ 0. -2 @ 0 };
				yourself.
	s2 := RTBox new width: 5; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAOrthogonalIconBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 14:39'!
visitDiveOutEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -2 @ 1. 1 @ 1. 1 @ -4. 3 @ -4. 3 @ -5. 0 @ -5. 0 @ 0. -2 @ 0 };
				yourself.
	s2 := RTBox new width: 5; height: 5; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1; 
		add: s2 translateBy: 0 @ 7.
	^ c! !

Object subclass: #GTAMenuBuilder
	instanceVariableNames: 'timelineBuilder menuBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 16:11'!
addEdges
	timelineBuilder withEdges; addEdges; signalUpdate.
	self configuration withEdges: timelineBuilder isWithEdges.! !

!GTAMenuBuilder methodsFor: 'building' stamp: 'JurajKubelka 4/14/2015 14:32'!
build
	self renderIn: timelineBuilder view.! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 15:07'!
colorMostOftenQueriesAndItemsInComputer
	| els bag hashes counts normalizer computers |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	computers := els collect: [ :e | e model session computer ] as: Set.
	bag := (computers flatCollect: [ :e | e userQueryOrSelectionHashes collect: #hash ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:38'!
colorMostOftenQueriesAndItemsInView
	| els bag hashes counts normalizer |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	bag := (els flatCollect: [ :e | e model userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:49'!
colorSameQueriesAndItemsInComputer
	| els bag hashes counts normalizer computers |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	computers := els collect: [ :e | e model session computer ] as: Set.
	bag := (computers flatCollect: [ :e | e userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTMultiLinearColorForIdentity new.
	normalizer objects: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:38'!
colorSameQueriesAndItemsInView
	| els bag hashes counts normalizer |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	bag := (els flatCollect: [ :e | e model userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTMultiLinearColorForIdentity new.
	normalizer objects: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAMenuBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:03'!
configuration
	^ GTADefaultTimelineConfiguration uniqueInstance! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	timelineBuilder shape flexibleResultShapes.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAMenuBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 4/14/2015 14:32'!
initialize
	super initialize.
	menuBuilder := RTMenuBuilder new.! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:01'!
logicalTimeline
	timelineBuilder
			logicalLayout;
			layoutElements;
			signalUpdate.
	self configuration 
			layout: timelineBuilder layout! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/16/2015 15:16'!
obliqueShapes
	timelineBuilder shape oblique.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/16/2015 15:16'!
orthogonalShapes
	timelineBuilder shape orthogonal.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:01'!
realTimeline
	timelineBuilder
			realLayout;
			layoutElements;
			signalUpdate.
	self configuration 
		layout: timelineBuilder layout! !

!GTAMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:04'!
removeEdges
	timelineBuilder withoutEdges; removeEdges; signalUpdate.
	self configuration withEdges: timelineBuilder isWithEdges.! !

!GTAMenuBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/20/2015 14:38'!
renderIn: aView
	menuBuilder view: aView.
	menuBuilder menu: 'Layout' submenu: 'Logical Timeline' callback: [ self logicalTimeline ].
	menuBuilder menu: 'Layout' submenu: 'Real Timeline' callback: [ self realTimeline ].
	menuBuilder menu: 'Edges' submenu: 'Remove' callback: [ self removeEdges ].
	menuBuilder menu: 'Edges' submenu: 'Add' callback: [ self addEdges ].
	menuBuilder menu: 'Events' submenu: 'Orthogonal Shapes' callback: [ self orthogonalShapes ].
	menuBuilder menu: 'Events' submenu: 'Flexible Result Shapes' callback: [ self flexibleResultShapes ].
	menuBuilder menu: 'Color' submenu: 'Same queries and items in view' callback: [ self colorSameQueriesAndItemsInView ].
	menuBuilder menu: 'Color' submenu: 'Most often queries and items in view' callback: [ self colorMostOftenQueriesAndItemsInView ].
	menuBuilder menu: 'Color' submenu: 'Same queries and items in computer' callback: [ self colorSameQueriesAndItemsInComputer ].
	menuBuilder menu: 'Color' submenu: 'Most often queries and items in computer' callback: [ self colorMostOftenQueriesAndItemsInComputer ].
! !

!GTAMenuBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 14:31'!
timelineBuilder: aGTATimelineBuilder 
	timelineBuilder := aGTATimelineBuilder! !

Object subclass: #GTAMultipleSelectionSendCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal'!

GTAMultipleSelectionSendCommand class
	instanceVariableNames: 'uniqueInstance'!

GTAMultipleSelectionSendCommand class
	instanceVariableNames: 'uniqueInstance'!

!GTAMultipleSelectionSendCommand class methodsFor: 'api' stamp: 'JurajKubelka 5/11/2015 11:01'!
selection: result in: aCollection
	^ self new selection: result in: aCollection! !

!GTAMultipleSelectionSendCommand class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 19:42'!
selection: result in: aCollection as: aCollectionClass
	^ self new selection: result in: aCollection as: aCollectionClass! !

!GTAMultipleSelectionSendCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:24'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTAMultipleSelectionSendCommand methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 19:39'!
selection: result in: aCollection
	^ self selection: result in: aCollection as: aCollection species! !

!GTAMultipleSelectionSendCommand methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 12:28'!
selection: result in: aCollection as: aCollectionClass
	^ result notNil 
		ifTrue: [ 
			(result size = 1)
				ifTrue: [result anyOne] 
				ifFalse: [ aCollectionClass withAll: result ] ]
		ifFalse: [ result ]! !

Object subclass: #GTARoughDataSetBuilder
	instanceVariableNames: 'objects groups comparator gap newGroupBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTARoughDataSetBuilder methodsFor: 'adding' stamp: 'JurajKubelka 5/11/2015 17:09'!
addToActualGroup: anObject 
	self ensureGroup.
	self groups last addLast: anObject.! !

!GTARoughDataSetBuilder methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 17:58'!
addToNewGroup: anObject
	^ self groups add: (self newGroupObject add: anObject; yourself) ! !

!GTARoughDataSetBuilder methodsFor: 'building' stamp: 'JurajKubelka 5/11/2015 18:14'!
build
	| lastObject |
	lastObject := self objects first.
	self objects doWithIndex: [ :object :index |
		index > 1 
			ifTrue: [ 
				(comparator cull: object cull: lastObject) < self gap
					ifTrue: [ self addToActualGroup: object ]
					ifFalse: [ self addToNewGroup: object ] ]
			ifFalse: [ self addToNewGroup: object ].
		lastObject := object.
	 ].
! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:50'!
comparator
	^ comparator! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:50'!
comparator: anObject
	comparator := anObject! !

!GTARoughDataSetBuilder methodsFor: 'private' stamp: 'JurajKubelka 5/14/2015 17:57'!
ensureGroup
	self groups ifEmpty: [ :aGroup | aGroup add: self newGroupObject ]! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 18:14'!
gap
	^ gap! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 18:14'!
gap: anInteger 
	gap := anInteger! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
groupClass: aClass
	self newGroupBlock: [ aClass new ]! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:55'!
groups
	^ groups ifNil: [ groups := GTAGroups new ]! !

!GTARoughDataSetBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/14/2015 17:58'!
initialize
	super initialize.
	comparator := [ :actualObject :previousObject | actualObject - previousObject ].
	newGroupBlock := [ GTAGroup new ].! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupBlock
	^ newGroupBlock! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupBlock: aBlockClosure 
	newGroupBlock := aBlockClosure! !

!GTARoughDataSetBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupObject
	^ self newGroupBlock value! !

!GTARoughDataSetBuilder methodsFor: 'helpers' stamp: 'JurajKubelka 5/11/2015 17:13'!
numberOfGroups
	^ self groups size ! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:07'!
objects
	^ objects! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 09:55'!
objects: aCollection 
	objects := aCollection.
	groups := nil.! !

!GTARoughDataSetBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/12/2015 09:51'!
setSessionComparator
	self comparator: [ :actualObject :previousObject | actualObject start - previousObject end ]! !

Object subclass: #GTASessionExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session1
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveInCategoryEvent new;
				add: GTSpotterRecorderContextChangedEvent new;
				add: GTSpotterRecorderSelectedCandidateChangedEvent new;
				add: GTSpotterRecorderCategorySelectedEvent new;
				add: GTSpotterRecorderDiveOutEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session2
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session3
	"Miss-steps"
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderSearchFinishedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:24'!
session4
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new; 
		add: GTSpotterRecorderShowPreviewEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderSearchFinishedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderActOnEvent new; 
		yourself! !

Object subclass: #GTATool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTATool class
	instanceVariableNames: 'semaphore process'!

GTATool class
	instanceVariableNames: 'semaphore process'!

!GTATool class methodsFor: 'private' stamp: 'JurajKubelka 5/13/2015 11:58'!
checkProcess
	process isComplete ifTrue: [ semaphore signal ].
! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:15'!
defaultDownloadDirectory
	^ FileSystem disk workingDirectory! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:18'!
defaultDownloadFilename
	^ self defaultDownloadDirectory / 'gt-events.tar.gz'! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:42'!
defaultEventsDirectory
	^ self defaultDownloadDirectory / 'gt' / 'events'! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:14'!
defaultUrl
	^ 'http://gc.dcc.uchile.cl:8080/gt/events/data'! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:17'!
download
	"self download"
 	UIManager default informUserDuring: [ :bar |
		bar label: 'Download Spotter Event Data...'.
		[ ZnClient new
			url: self defaultUrl;
			downloadTo: self defaultDownloadFilename ]
		on: HTTPProgress 
		do: [ :progress |
			progress isEmpty ifFalse: [ bar current: progress percentage ].
			progress resume ] 
	]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:40'!
ensureDownloadedData
	self defaultDownloadFilename exists ifFalse: [ self download ]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:41'!
ensureExctractedData
	self defaultEventsDirectory exists ifFalse: [ self extract ]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:39'!
ensureLocalDirectory
	self 
		ensureDownloadedData;
		ensureExctractedData! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:58'!
extract
	semaphore := Semaphore new.
	process := ExternalUnixOSProcess 
		forkAndExec: '/usr/bin/tar' 
		arguments: (Array with: 'xzf' with: self defaultDownloadFilename fullName)
		environment: nil 
		descriptors: nil 
		workingDir: self defaultDownloadDirectory fullName.
	process addDependent: self.
	self checkProcess.
	semaphore wait.
	process := nil.
	semaphore := nil.! !

!GTATool class methodsFor: 'updating' stamp: 'JurajKubelka 5/13/2015 11:57'!
update: aParameter
	aParameter = #runState ifTrue: [ self checkProcess ]! !

Object subclass: #GTSpotterAnalysisCommand
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

GTSpotterAnalysisCommand subclass: #GTAPreviousSelectionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAPreviousSelectionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 12:25'!
analysisOrder
	^ (GTSpotterElementWithCategoryCommand analysisOrder max:
			GTSpotterDiveInLevelCommand analysisOrder) + 1! !

!GTAPreviousSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 12:40'!
clean
	self session do: [ :each | 
		each isUserSelectionClass ifTrue: [ each removePreviousSelection ] ]! !

!GTAPreviousSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 12:34'!
execute
	| selections diveInLevels |
	selections := self session select: #isUserSelectionClass.
	selections size < 2 ifTrue: [ ^ self ].
	diveInLevels := Dictionary new.
	selections withIndexDo: [ :selection :index | | lastSelection |
		lastSelection := diveInLevels at: selection diveInLevel ifAbsent: [ nil ].
		lastSelection ifNotNil: [ selection previousSelection: lastSelection ].
		diveInLevels at: selection diveInLevel put: selection ]! !

!GTSpotterAnalysisCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:13'!
analysisOrder
	^ 100! !

!GTSpotterAnalysisCommand class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: aGTSpotterSession 
	^ self new context: aGTSpotterSession; yourself! !

!GTSpotterAnalysisCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:12'!
clean
	self subclassResponsibility! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context
	^ context! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: anObject
	context := anObject! !

!GTSpotterAnalysisCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 11:31'!
execute
	self subclassResponsibility! !

!GTSpotterAnalysisCommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:32'!
session
	^ self context session! !

GTSpotterAnalysisCommand subclass: #GTSpotterDiveInLevelCommand
	instanceVariableNames: 'dives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterDiveInLevelCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 1! !

!GTSpotterDiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:23'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeDiveInEvent;
			removeSameLevelEvents ]! !

!GTSpotterDiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 12:00'!
execute
	self session do: [ :eachEvent |
		eachEvent isDiveIn ifTrue: [ self updateDiveIn: eachEvent ].
		eachEvent isDiveOut ifTrue: [ self updateDiveOut: eachEvent ].
		eachEvent isDive ifFalse: [ self updateEvent: eachEvent ].
	]! !

!GTSpotterDiveInLevelCommand methodsFor: 'initialization' stamp: 'JurajKubelka 3/31/2015 12:06'!
initialize
	super initialize.
	dives := OrderedCollection new! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:58'!
updateDiveIn: anEvent
	self updateEvent: anEvent.
	dives add: anEvent.
! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:11'!
updateDiveOut: anEvent
	dives ifEmpty: [ ^ anEvent markAsStrange: 'Dive-Out before Dive-In.' ].
	self updateEvent: anEvent.
	dives removeLast ! !

!GTSpotterDiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 12:11'!
updateEvent: anEvent
	dives ifEmpty: [ ^ self ].
	anEvent diveInEvent: dives last.
	dives last addSameLevelEvent: anEvent.
! !

GTSpotterAnalysisCommand subclass: #GTSpotterElementWithCategoryCommand
	instanceVariableNames: 'selection category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterElementWithCategoryCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:10'!
analysisOrder
	^ 1! !

!GTSpotterElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:25'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeStrange;
			removeSelectedCategoryEvent;
			removeSelectedElementEvents ]! !

!GTSpotterElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 14:10'!
execute
	self session do: [ :eachEvent |
		eachEvent isUserSelectionClass ifTrue: [ self updateSelection: eachEvent ].
		eachEvent isCategorySelection ifTrue: [ self updateCategory: eachEvent ].
	].
	self updateSelection: nil.! !

!GTSpotterElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:44'!
updateCategory: anEvent
	selection ifNil: [ ^ anEvent markAsStrange: 'Category selection before element selection.' ].
	selection selectedCategoryEvent: anEvent.
	anEvent selectedElementEvent: selection.
	selection := nil.
	category := anEvent.! !

!GTSpotterElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:43'!
updateSelection: anEvent
	selection ifNotNil: [ 
		category 
			ifNil: [ selection markAsStrange: 'There is no category selection before.' ]
			ifNotNil: [ :aCategory | 
				selection selectedCategoryEvent: aCategory.
				aCategory selectedElementEvent: selection.  ]
		 ].
	selection := anEvent.! !

GTSpotterAnalysisCommand subclass: #GTSpotterLinkToSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterLinkToSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:09'!
analysisOrder
	^ 1! !

!GTSpotterLinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
clean
	self session do: [ :eachEvent |
		eachEvent removeSession ]! !

!GTSpotterLinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
execute
	self session do: [ :eachEvent |
		eachEvent session: self session ]! !

GTSpotterAnalysisCommand subclass: #GTSpotterMissStepsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterMissStepsCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 50! !

!GTSpotterMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:26'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeIsMissStep ]! !

!GTSpotterMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/8/2015 16:53'!
execute
	| divesIn |
	divesIn := self session select: #isDiveIn.
	divesIn withIndexDo: [ :aDiveIn :index |
		(index + 1) <= divesIn size ifTrue: [ 
			((aDiveIn hasQuery or: [ aDiveIn hasDiveIn ]) not and:
				[ aDiveIn duration < 3 seconds ]) ifTrue: [ 
				aDiveIn setMissStep.
			]
		]
	]! !

GTSpotterAnalysisCommand subclass: #GTSpotterSameTimestampCommand
	instanceVariableNames: 'timestamp events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSameTimestampCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:08'!
analysisOrder
	^ GTSpotterLinkToSessionCommand analysisOrder + 1! !

!GTSpotterSameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:09'!
addEvent: aSpotterEvent 
	events ifNil: [ events := OrderedCollection new ].
	events addLast: aSpotterEvent! !

!GTSpotterSameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 19:25'!
clean
	self session do: [ :event | event removeSameTimeEvents ]! !

!GTSpotterSameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:27'!
consolidateEvents: aDateAndTime 
	events ifNil: [ ^ self ].
	events withIndexDo: [ :event :index |
		event sameTimeEvents: events index: index nextDateAndTime: aDateAndTime ].
	events := nil.! !

!GTSpotterSameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/11/2015 22:50'!
execute
	| eventTimestamp |
	self session do: [ :eachEvent | 
		eventTimestamp := eachEvent dateAndTimeWithFixedTimeZone.
		timestamp 
			ifNil: [ 
				timestamp := eventTimestamp.
				self addEvent: eachEvent. ]
			ifNotNil: [ 
				timestamp = eventTimestamp 
					ifTrue: [ self addEvent: eachEvent ] 
					ifFalse: [ self consolidateEvents: eventTimestamp.
						timestamp := eventTimestamp.
						self addEvent: eachEvent. ] ]
		 ].
	self consolidateEvents: eventTimestamp! !

Object subclass: #GTSpotterEventIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:36'!
actOnIcon
	^ Smalltalk ui icons glamorousPlay! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:43'!
contextChangedIcon
	^ Smalltalk ui icons glamorousEdit  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:20'!
diveInCategoryIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInCategoryMissStepIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon
		deepCopy 
			mapColor: (Color r: 0.581 g: 0.581 b: 0.581 alpha: 1.0)
			to: Color red! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
diveInElementIcon
	^ Smalltalk ui icons glamorousDiveRightIcon  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInElementMissStepIcon
	^ Smalltalk ui icons glamorousDiveRightIcon 
			deepCopy mapColor: Color black to: Color red! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:41'!
diveOutIcon
	^ Smalltalk ui icons glamorousLeft  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:46'!
exitIcon
	^ Smalltalk ui icons glamorousClose  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
hidePreviewIcon
	^ Smalltalk ui icons glamorousZoomOut! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
noIcon
	^ Smalltalk ui icons protocolNoneIcon! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:45'!
selectedCandidateChangedIcon
	^ Smalltalk ui icons glamorousGrayCircle  ! !

!GTSpotterEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
showPreviewIcon
	^ Smalltalk ui icons glamorousZoomIn! !

Object subclass: #GTSpotterPrintDateAndTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterPrintDateAndTime class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 13:48'!
yyyyMmDdAndHhMmSs: aDateAndTimeOrZero
	"Returns YYYY-MM-DD, HH:MM:SS in UTC time."
	aDateAndTimeOrZero = 0 ifTrue: [ ^ 'unknown' ].
	^ String streamContents: [ :aStream |
		aDateAndTimeOrZero asUTC printYMDOn: aStream.
		aStream nextPutAll: ', '.
		aDateAndTimeOrZero asUTC printHMSOn: aStream ] ! !

Object subclass: #GTSpotterSessionAnalysis
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 3/31/2015 11:50'!
executeOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) execute! !

!GTSpotterSessionAnalysis class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: aGTSpotterSession 
	^ self new session: aGTSpotterSession; yourself! !

!GTSpotterSessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 11:13'!
updateOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) clean; execute! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/13/2015 14:52'!
analyze: aCollection 
	self 
		session: aCollection;
		clean; 
		execute! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:15'!
clean
	(GTSpotterAnalysisCommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command clean ].
	^ self session! !

!GTSpotterSessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/8/2015 16:31'!
execute
	(GTSpotterAnalysisCommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command execute ].
	^ self session! !

!GTSpotterSessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session
	^ session! !

!GTSpotterSessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: anObject
	session := anObject! !

Object subclass: #GTSpotterSessionsBuilder
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTSpotterSessionsBuilder commentStamp: 'JurajKubelka 3/31/2015 11:24' prior: 0!
I'm a session builder, I receive collected announcements and split events per computer and per session. Session starts with opening Spotter and finishs on closing Spotter.!

!GTSpotterSessionsBuilder class methodsFor: 'api' stamp: 'JurajKubelka 3/30/2015 15:48'!
fromEvents: aCollection 
	^ self new events: aCollection; sessions! !

!GTSpotterSessionsBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:48'!
events: aCollection 
	events := aCollection! !

!GTSpotterSessionsBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 5/11/2015 16:11'!
sessions 
	| borders pairs openOrExit previousAssociation computer |
	events ifEmpty: [ ^ GTAComputer new ].
	borders := events withIndexCollect: [ :event :index |
		event isOpenOrCloseSpotter 
				ifTrue: [ index -> event ]
				ifFalse: [ nil ]
		 ].
	borders := borders select: [ :each | each notNil ].
	pairs := OrderedCollection new.
	openOrExit := #open.
	previousAssociation := borders first.
	borders do: [ :eachAssociation |
		(openOrExit = #open) 
			ifTrue: [ 
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs addLast: eachAssociation. 
					openOrExit := #exit ] ]
			ifFalse: [ 
				eachAssociation value isCloseSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> eachAssociation. 
					openOrExit := #open ].
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> previousAssociation.
					pairs addLast: eachAssociation.
					openOrExit := #exit ] ].
		previousAssociation := eachAssociation.
	].
	openOrExit = #exit ifTrue: [ pairs removeLast ].
	computer := pairs collect: [ :eachPair | | open exit |
		open := eachPair key.
		exit := eachPair value.
		GTASession withAll: (events copyFrom: open key to: exit key).
		 ] as: GTAComputer.
	computer do: [ :eachSession | eachSession computer: computer ].
	^ computer! !

Object subclass: #GTSpotterTimeline
	instanceVariableNames: 'data view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Support'!

!GTSpotterTimeline class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 18:34'!
viewOn: objects
	^ self new
			data: objects;
			build;
			view! !

!GTSpotterTimeline methodsFor: 'building' stamp: 'JurajKubelka 4/14/2015 11:17'!
build
	| shape elements visibleData levels |
	view := RTView new.
	view @ RTDraggableView.
	shape := RTBitmap new.
	shape form: #analysisIcon.
	visibleData := self visibleData.
	levels := visibleData deepestDiveIn.
	elements := shape elementsOn: visibleData.
	elements @ RTDraggable @ (RTPopup text: #asEventAnalysisString).
	view addAll: elements.
	"RTGridLayout on: elements."
	RTMetricNormalizer new
		elements: elements;
		normalizeX: [ :eachEvent | self xFor: eachEvent ] min: 0 max: 500;
		normalizeY: [ :eachEvent | self yFor: eachEvent ] min: 0 max: (levels * 4).
! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data
	^ data! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data: anObject
	data := anObject! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view
	^ view! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view: anObject
	view := anObject! !

!GTSpotterTimeline methodsFor: 'enumerating' stamp: 'JurajKubelka 4/9/2015 19:52'!
visibleData
	^ self data select: #isForTimelineView! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:14'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

!GTSpotterTimeline methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 20:15'!
yFor: aSpotterEvent
	^ aSpotterEvent diveInLevel! !

!Object methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 10:37'!
isSpotterEvent
	^ false! !
